# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" />
#<program4xi program = "kernel4xi5test.py">
#<abstract4xi abstract = "tests kernel4xi.py"/>
#<verify4xi verification = "11" target = "kernel4xi5test.py"/>
#<contextualize4xi context = "kernel4xi.py"/>
#<use4xi usage = "
# SET:
# 
# RUN:
# > python kernel4xi5test.py > E:\scope4xi\041721\zap\work\txt\kernel4xi5test.txt
#
# ANALYZE:
#
# sense-test-kernel4xi5test.xml     <-- trace in XML
# reason-test-kernel4xi5test.xml
# ace-test-kernel4xi5test.xml
# kernel4xi5test.txt                <-- OF KERNEL4XI5TEST
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['kernel4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
# None

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from program4xi import Program4Xi
from program4xi import add2programwithbinary4xi       
from program4xi import add2programwithsource4xi
                                
from program4xi import build2program4xi 

from program4xi import compile2program4xi      
from program4xi import create2programwithsource4xi
from program4xi import create2programwithbinary4xi
# from program4xi import create2programwithbuiltinkernels4xi
                       
from program4xi import delete2programwithbinary4xi
from program4xi import delete2programwithsource4xi     

from program4xi import get2programinfo4xi
from program4xi import get2programbuildinfo4xi
            
from program4xi import link2program4xi                 
from program4xi import release2program4xi                                 
from program4xi import retain2program4xi
 
from program4xi import set2programwithsource4xi
from program4xi import set2programwithbinary4xi
from program4xi import set2programcallback4xi
                              
from program4xi import trace2program4xi
# from program4xi import unload2compiler4xi

# -------------------------------------------------------------------------------------------------
# Kernel module                           
# -------------------------------------------------------------------------------------------------
from kernel4xi import Kernel4Xi

from kernel4xi import add2kernel4xi       
                                
from kernel4xi import execute2kernel4xi 
from kernel4xi import execute2task4xi 
from kernel4xi import execute2nativekernel4xi 

from kernel4xi import create2kernel4xi
from kernel4xi import create2kernelsinprogram4xi

from kernel4xi import delete2kernel4xi

from kernel4xi import get2kernelinfo4xi
from kernel4xi import get2kernelworkgroupinfo4xi
from kernel4xi import get2kernelarginfo4xi
      
from kernel4xi import release2kernel4xi                                 
from kernel4xi import retain2kernel4xi
 
from kernel4xi import set2kernel4xi
from kernel4xi import set2kernelarg4xi
from kernel4xi import set2kernelcallback4xi
                              
from kernel4xi import trace2kernel4xi

# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global KB4Focus                                                         # Focus knowledgebase
global KB2PU
global keys2pu
global keys2cc

global folder2lib4zpu
global folder2lib4apu

global PickleKB4Xi

global trace2scope 
global trace_object_count
                                                                       
# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
KB4Focus = {                                             #  NACK= Focus; (01) = first focus (02) = second focus etc 
         # ================
         # FUNCTIONS
         # ================                                     
         'add2kernel4xi':                    'NACK4XI',  # (FOCUS 04)         
         'execute2kernel4xi':                'ACK4XI',  # (FOCUS 19)
         'get2kernelarginfo4xi':             'ACK4XI',  # (FOCUS 02)
         'create2kernel4xi':                 'NACK4XI',  # (FOCUS 01) - CREATE FUNCTION MIGHT BE REQUIRED TO TEST SOME OTHER FUNCTIONS SUCH AS SET AND DELETE!
         'create2kernelsinprogram4xi':       'ACK4XI',  # (FOCUS 07) - CREATE FUNCTION MIGHT BE REQUIRED TO TEST SOME OTHER FUNCTIONS SUCH AS SET AND DELETE!
         'delete2kernel4xi':                 'ACK4XI',  # (FOCUS 05)
         'delete2kernel4xi':                 'ACK4XI',  # (FOCUS 09)              
         'get2kernelinfo4xi':                'NACK4XI',  # (FOCUS 02,06,10,11) needed by other 
         'get2kernelworkgroupinfo4xi':       'ACK4XI',
         'release2kernel4xi':                'ACK4XI',  # (FOCUS 15
         'retain2kernel4xi':                 'ACK4XI',  # (FOCUS 16))        
         'set2kernelcallback4xi':            'ACK4XI',  # (FOCUS 17)
         'set2kernel4xi':                    'ACK4XI',  # (FOCUS 12)
         'set2kernelarg4xi':                 'ACK4XI',  # (FOCUS 14)     
         'trace2kernel4xi':                  'ACK4XI',  # (FOCUS 18)
         'unload2compiler4xi':               'ACK4XI',
         # ================
         # CLASS
         # ================               
         'Kernel4Xi':                        'ACK4XI',  # (FOCUS 110) - CLASS  - MANDATORY TO HAVE ANY METHOD IN FOCUS - NOTE THAT __INIT__ METHOD CALLS CREATE2KERNELWITH!
         'add2kernel':                       'ACK4XI',  # (FOCUS 122, 132)  
         'execute2kernel':                   'ACK4XI',  # (FOCUS 240)
         'get2kernelarginfo':                'ACK4XI',  # (FOCUS 121A)
         'create2kernel':                    'ACK4XI',  # (FOCUS 190)
         'create2kernelsinprogram':          'ACK4XI',  # (FOCUS 130) - REQUIRED FOR (FOCUS 160)
         'delete2kernel':                    'ACK4XI',  # (FOCUS 124)    
         'delete2kernel':                    'ACK4XI',  # (FOCUS 134)            
         'get2kernelinfo':                   'ACK4XI',  # (FOCUS 140)  
         'get2kernelworkgroupinfo':          'ACK4XI',  # 
         'release2kernel':                   'ACK4XI',  # (FOCUS 170,220)
         'retain2kernel':                    'ACK4XI',  # (FOCUS 180,230) 
         'set2kernelcallback':               'ACK4XI',  # (FOCUS 200) 
         'set2kernel':                       'ACK4XI',  # (FOCUS 150)
         'set2kernelarg':                    'ACK4XI',  # (FOCUS 160)            
         'trace2kernel':                     'ACK4XI',  # (FOCUS 210) 
         'unload2compiler':                  'ACK4XI',  #
         'sense':                            'ACK4XI',  # (FOCUS 310)
         'reason':                           'ACK4XI',  # (FOCUS 320)
         'ace':                              'ACK4XI'   # (FOCUS 330)                                 
        }                                                # TIP: SEARCH WITH FOCUS NN IN TEST OUT FILE, WHERE NN = 01,02 ...  

KB2PU = {}                      # PROCESSING UNITS
KB2PU ['APU'] = {}
KB2PU ['BPU'] = {}
KB2PU ['CPU'] = {}
KB2PU ['DPU'] = {}
KB2PU ['EPU'] = {}
KB2PU ['FPU'] = {}
KB2PU ['GPU'] = {}
KB2PU ['HPU'] = {}
KB2PU ['IPU'] = {}
KB2PU ['JPU'] = {}
KB2PU ['KPU'] = {}
KB2PU ['LPU'] = {}
KB2PU ['MPU'] = {}
KB2PU ['NPU'] = {}
KB2PU ['OPU'] = {}
KB2PU ['PPU'] = {}
KB2PU ['QPU'] = {}
KB2PU ['RPU'] = {}
KB2PU ['SPU'] = {}
KB2PU ['TPU'] = {}
KB2PU ['UPU'] = {}
KB2PU ['VPU'] = {}
KB2PU ['WPU'] = {}
KB2PU ['XPU'] = {}
KB2PU ['YPU'] = {}
KB2PU ['ZPU'] = {}
keys2pu = KB2PU.keys()

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       # 
       'b': Pickle2b4Xi,
       # 
       'c': Pickle2c4Xi,
       # 
       'd': Pickle2d4Xi,
       # 
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

temp2apu = 'apu'
key2dir = temp2apu[0]                                    # MORE COMPLIATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4apu = VersionKB4Xi[key2dir]        

temp2zpu = 'zpu'
key2dir = temp2zpu[0]                                    # MORE COMPLIATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4zpu = VersionKB4Xi[key2dir]  

#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                trace2scope.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            trace2scope.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global trace2scope
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
           # ===
           # XI
           # ===
           'Kernel4Xi':                                     'ACK4XI',   #  CLASS TRACE WILL PRODUCE TRACE FROM ALL METHODS FOR XI= {APU ... ZPU}! 
           'add2kernel4xi':                                 'ACK4XI',   # (FOCUS 04)  
           'execute2kernel4xi':                             'ACK4XI',   #   
           'get2kernelarginfo4xi':                          'ACK4XI',   #        
           'create2kernel4xi':                              'ACK4XI',   # (FOCUS 01) 
           'create2kernelsinprogram4xi':                    'ACK4XI',   # (FOCUS 07)   
           'create2kernelwithbuiltinkernels4xi':            'ACK4XI',   # 
           'delete2kernel4xi':                              'ACK4XI',   # (FOCUS 09)
           'delete2kernel4xi':                              'ACK4XI',   # (FOCUS 05)     
           'fetch2kernelbinary4xi':                         'ACK4XI',   # 
           'fetch2kernelsource4xi':                         'ACK4XI',   # 
           'get2kernelinfo4xi':                             'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4xi':                    'ACK4XI',   # 
        
           'release2kernel4xi':                             'ACK4XI',   #                                   
           'retain2kernel4xi':                              'ACK4XI',   # 
           'set2kernel4xi':                                 'ACK4XI',   # (FOCUS 12)  
           'set2kernelarg4xi':                              'ACK4XI',   # (FOCUS 14)   
           'set2kernelcallback4xi':                         'ACK4XI',   # 
           'trace2kernel4xi':                               'ACK4XI',   # 
           'unload2compiler4xi':                            'ACK4XI',   # 
           # ===
           # APU
           # ===                                             
           'APU2Kernel4Xi':                                 'ACK4XI',   # CLASS TRACE WILL PRODUCE TRACE FROM ALL METHODS FOR APU! 
           'add2kernel4apu':                                'NACK4XI',   # (FOCUS 04) 
           'execute2kernel4apu':                            'ACK4XI',   #   
           'get2kernelarginfo4apu':                         'ACK4XI',   #        
           'create2kernel4apu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4apu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4apu':           'ACK4XI',   # 
           'delete2kernel4apu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4apu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4apu':                        'ACK4XI',   # 
           'fetch2kernelsource4apu':                        'ACK4XI',   # 
           'get2kernelinfo4apu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4apu':                   'ACK4XI',   # 
 
           'release2kernel4apu':                            'ACK4XI',   #                                   
           'retain2kernel4apu':                             'ACK4XI',   # 
           'set2kernel4apu':                                'ACK4XI',   # 
           'set2kernelarg4apu':                             'ACK4XI',   # (FOCUS 14)     
           'set2kernelcallback4apu':                        'ACK4XI',   # 
           'trace2kernel4apu':                              'ACK4XI',   # 
           'unload2compiler4apu':                           'ACK4XI',   # 
           # ===
           # BPU
           # ===                                             
           'BPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4bpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4bpu':                            'ACK4XI',   #   
           'get2kernelarginfo4bpu':                         'ACK4XI',   #        
           'create2kernel4bpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4bpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4bpu':           'ACK4XI',   # 
           'delete2kernel4bpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4bpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4bpu':                        'ACK4XI',   # 
           'fetch2kernelsource4bpu':                        'ACK4XI',   # 
           'get2kernelinfo4bpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4bpu':                   'ACK4XI',   # 
  
           'release2kernel4bpu':                            'ACK4XI',   #                                   
           'retain2kernel4bpu':                             'ACK4XI',   # 
           'set2kernel4bpu':                                'ACK4XI',   # 
           'set2kernelarg4bpu':                             'ACK4XI',   #   
           'set2kernelcallback4bpu':                        'ACK4XI',   # 
           'trace2kernel4bpu':                              'ACK4XI',   # 
           'unload2compiler4bpu':                           'ACK4XI',   # 
           # ===
           # CPU
           # ===                                             
           'DPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4cpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4cpu':                            'ACK4XI',   #   
           'get2kernelarginfo4cpu':                         'ACK4XI',   #        
           'create2kernel4cpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4cpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4cpu':           'ACK4XI',   # 
           'delete2kernel4cpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4cpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4cpu':                        'ACK4XI',   # 
           'fetch2kernelsource4cpu':                        'ACK4XI',   # 
           'get2kernelinfo4cpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4cpu':                   'ACK4XI',   # 
          
           'release2kernel4cpu':                            'ACK4XI',   #                                   
           'retain2kernel4cpu':                             'ACK4XI',   # 
           'set2kernel4cpu':                                'ACK4XI',   # 
           'set2kernelarg4cpu':                             'ACK4XI',   #   
           'set2kernelcallback4cpu':                        'ACK4XI',   # 
           'trace2kernel4cpu':                              'ACK4XI',   # 
           'unload2compiler4cpu':                           'ACK4XI',   # 
           # ===
           # DPU
           # ===                                             
           'DPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4dpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4dpu':                            'ACK4XI',   #   
           'get2kernelarginfo4dpu':                         'ACK4XI',   #        
           'create2kernel4dpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4dpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4dpu':           'ACK4XI',   # 
           'delete2kernel4dpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4dpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4dpu':                        'ACK4XI',   # 
           'fetch2kernelsource4dpu':                        'ACK4XI',   # 
           'get2kernelinfo4dpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4dpu':                   'ACK4XI',   # 
        
           'release2kernel4dpu':                            'ACK4XI',   #                                   
           'retain2kernel4dpu':                             'ACK4XI',   # 
           'set2kernel4dpu':                                'ACK4XI',   # 
           'set2kernelarg4dpu':                             'ACK4XI',   #   
           'set2kernelcallback4dpu':                        'ACK4XI',   # 
           'trace2kernel4dpu':                              'ACK4XI',   # 
           'unload2compiler4dpu':                           'ACK4XI',   # 
           # ===
           # EPU
           # ===                                             
           'EPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4epu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4epu':                            'ACK4XI',   #   
           'get2kernelarginfo4epu':                         'ACK4XI',   #        
           'create2kernel4epu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4epu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4epu':           'ACK4XI',   # 
           'delete2kernel4epu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4epu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4epu':                        'ACK4XI',   # 
           'fetch2kernelsource4epu':                        'ACK4XI',   # 
           'get2kernelinfo4epu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4epu':                   'ACK4XI',   # 
       
           'release2kernel4epu':                            'ACK4XI',   #                                   
           'retain2kernel4epu':                             'ACK4XI',   # 
           'set2kernel4epu':                                'ACK4XI',   # 
           'set2kernelarg4epu':                             'ACK4XI',   #   
           'set2kernelcallback4epu':                        'ACK4XI',   # 
           'trace2kernel4epu':                              'ACK4XI',   # 
           'unload2compiler4epu':                           'ACK4XI',   # 
           # ===
           # FPU
           # ===                                             
           'FPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4fpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4fpu':                            'ACK4XI',   #   
           'get2kernelarginfo4fpu':                         'ACK4XI',   #        
           'create2kernel4fpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4fpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4fpu':           'ACK4XI',   # 
           'delete2kernel4fpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4fpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4fpu':                        'ACK4XI',   # 
           'fetch2kernelsource4fpu':                        'ACK4XI',   # 
           'get2kernelinfo4fpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4fpu':                   'ACK4XI',   # 

           'release2kernel4fpu':                            'ACK4XI',   #                                   
           'retain2kernel4fpu':                             'ACK4XI',   # 
           'set2kernel4fpu':                                'ACK4XI',   # 
           'set2kernelarg4fpu':                             'ACK4XI',   #   
           'set2kernelcallback4fpu':                        'ACK4XI',   # 
           'trace2kernel4fpu':                              'ACK4XI',   # 
           'unload2compiler4fpu':                           'ACK4XI',   # 
           # ===
           # GPU
           # ===                                             
           'GPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4gpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4gpu':                            'ACK4XI',   #   
           'get2kernelarginfo4gpu':                         'ACK4XI',   #        
           'create2kernel4gpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4gpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4gpu':           'ACK4XI',   # 
           'delete2kernel4gpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4gpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4gpu':                        'ACK4XI',   # 
           'fetch2kernelsource4gpu':                        'ACK4XI',   # 
           'get2kernelinfo4gpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4gpu':                   'ACK4XI',   # 
        
           'release2kernel4gpu':                            'ACK4XI',   #                                   
           'retain2kernel4gpu':                             'ACK4XI',   # 
           'set2kernel4gpu':                                'ACK4XI',   # 
           'set2kernelarg4gpu':                             'ACK4XI',   #   
           'set2kernelcallback4gpu':                        'ACK4XI',   # 
           'trace2kernel4gpu':                              'ACK4XI',   # 
           'unload2compiler4gpu':                           'ACK4XI',   # 
           # ===
           # HPU
           # ===                                             
           'HPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4hpu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4hpu':                            'ACK4XI',   #   
           'get2kernelarginfo4hpu':                         'ACK4XI',   #        
           'create2kernel4hpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4hpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4hpu':           'ACK4XI',   # 
           'delete2kernel4hpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4hpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4hpu':                        'ACK4XI',   # 
           'fetch2kernelsource4hpu':                        'ACK4XI',   # 
           'get2kernelinfo4hpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4hpu':                   'ACK4XI',   # 
            
           'release2kernel4hpu':                            'ACK4XI',   #                                   
           'retain2kernel4hpu':                             'ACK4XI',   # 
           'set2kernel4hpu':                                'ACK4XI',   # 
           'set2kernelarg4hpu':                             'ACK4XI',   #   
           'set2kernelcallback4hpu':                        'ACK4XI',   # 
           'trace2kernel4hpu':                              'ACK4XI',   # 
           'unload2compiler4hpu':                           'ACK4XI',   # 
           # ===
           # IPU
           # ===                                             
           'IPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4ipu':                                'ACK4XI',   # (FOCUS 04) 
           'execute2kernel4ipu':                            'ACK4XI',   #   
           'get2kernelarginfo4ipu':                         'ACK4XI',   #        
           'create2kernel4ipu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4ipu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4ipu':           'ACK4XI',   # 
           'delete2kernel4ipu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4ipu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4ipu':                        'ACK4XI',   # 
           'fetch2kernelsource4ipu':                        'ACK4XI',   # 
           'get2kernelinfo4ipu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4ipu':                   'ACK4XI',   # 
 
           'release2kernel4ipu':                            'ACK4XI',   #                                   
           'retain2kernel4ipu':                             'ACK4XI',   # 
           'set2kernel4ipu':                                'ACK4XI',   # 
           'set2kernelarg4ipu':                             'ACK4XI',   #   
           'set2kernelcallback4ipu':                        'ACK4XI',   # 
           'trace2kernel4ipu':                              'ACK4XI',   # 
           'unload2compiler4ipu':                           'ACK4XI',   # 
           # ===
           # JPU
           # ===                                             
           'JPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4jpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4jpu':                            'ACK4XI',   #   
           'get2kernelarginfo4jpu':                         'ACK4XI',   #        
           'create2kernel4jpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4jpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4jpu':           'ACK4XI',   # 
           'delete2kernel4jpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4jpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4jpu':                        'ACK4XI',   # 
           'fetch2kernelsource4jpu':                        'ACK4XI',   # 
           'get2kernelinfo4jpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4jpu':                   'ACK4XI',   # 
 
           'release2kernel4jpu':                            'ACK4XI',   #                                   
           'retain2kernel4jpu':                             'ACK4XI',   # 
           'set2kernel4jpu':                                'ACK4XI',   # 
           'set2kernelarg4jpu':                             'ACK4XI',   #   
           'set2kernelcallback4jpu':                        'ACK4XI',   # 
           'trace2kernel4jpu':                              'ACK4XI',   # 
           'unload2compiler4jpu':                           'ACK4XI',   # 
           # ===
           # KPU
           # ===                                             
           'KPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4kpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4kpu':                            'ACK4XI',   #   
           'get2kernelarginfo4kpu':                         'ACK4XI',   #        
           'create2kernel4kpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4kpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4kpu':           'ACK4XI',   # 
           'delete2kernel4kpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4kpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4kpu':                        'ACK4XI',   # 
           'fetch2kernelsource4kpu':                        'ACK4XI',   # 
           'get2kernelinfo4kpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4kpu':                   'ACK4XI',   # 
       
           'release2kernel4kpu':                            'ACK4XI',   #                                   
           'retain2kernel4kpu':                             'ACK4XI',   # 
           'set2kernel4kpu':                                'ACK4XI',   # 
           'set2kernelarg4kpu':                             'ACK4XI',   #   
           'set2kernelcallback4kpu':                        'ACK4XI',   # 
           'trace2kernel4kpu':                              'ACK4XI',   # 
           'unload2compiler4kpu':                           'ACK4XI',   # 
           # ===
           # LPU
           # ===                                             
           'LPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4lpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4lpu':                            'ACK4XI',   #   
           'get2kernelarginfo4lpu':                         'ACK4XI',   #        
           'create2kernel4lpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4lpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4lpu':           'ACK4XI',   # 
           'delete2kernel4lpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4lpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4lpu':                        'ACK4XI',   # 
           'fetch2kernelsource4lpu':                        'ACK4XI',   # 
           'get2kernelinfo4lpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4lpu':                   'ACK4XI',   # 
         
           'release2kernel4lpu':                            'ACK4XI',   #                                   
           'retain2kernel4lpu':                             'ACK4XI',   # 
           'set2kernel4lpu':                                'ACK4XI',   # 
           'set2kernelarg4lpu':                             'ACK4XI',   #   
           'set2kernelcallback4lpu':                        'ACK4XI',   # 
           'trace2kernel4lpu':                              'ACK4XI',   # 
           'unload2compiler4lpu':                           'ACK4XI',   # 
           # ===
           # MPU
           # ===                                             
           'MPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4mpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4mpu':                            'ACK4XI',   #   
           'get2kernelarginfo4mpu':                         'ACK4XI',   #        
           'create2kernel4mpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4mpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4mpu':           'ACK4XI',   # 
           'delete2kernel4mpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4mpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4mpu':                        'ACK4XI',   # 
           'fetch2kernelsource4mpu':                        'ACK4XI',   # 
           'get2kernelinfo4mpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4mpu':                   'ACK4XI',   # 
        
           'release2kernel4mpu':                            'ACK4XI',   #                                   
           'retain2kernel4mpu':                             'ACK4XI',   # 
           'set2kernel4mpu':                                'ACK4XI',   # 
           'set2kernelarg4mpu':                             'ACK4XI',   #   
           'set2kernelcallback4mpu':                        'ACK4XI',   # 
           'trace2kernel4mpu':                              'ACK4XI',   # 
           'unload2compiler4mpu':                           'ACK4XI',   # 
           # ===
           # NPU
           # ===                                             
           'NPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4npu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4npu':                            'ACK4XI',   #   
           'get2kernelarginfo4npu':                         'ACK4XI',   #        
           'create2kernel4npu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4npu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4npu':           'ACK4XI',   # 
           'delete2kernel4npu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4npu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4npu':                        'ACK4XI',   # 
           'fetch2kernelsource4npu':                        'ACK4XI',   # 
           'get2kernelinfo4npu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4npu':                   'ACK4XI',   # 
     
           'release2kernel4npu':                            'ACK4XI',   #                                   
           'retain2kernel4npu':                             'ACK4XI',   # 
           'set2kernel4npu':                                'ACK4XI',   # 
           'set2kernelarg4npu':                             'ACK4XI',   #   
           'set2kernelcallback4npu':                        'ACK4XI',   # 
           'trace2kernel4npu':                              'ACK4XI',   # 
           'unload2compiler4npu':                           'ACK4XI',   # 
           # ===
           # OPU
           # ===                                             
           'OPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4opu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4opu':                            'ACK4XI',   #   
           'get2kernelarginfo4opu':                         'ACK4XI',   #        
           'create2kernel4opu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4opu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4opu':           'ACK4XI',   # 
           'delete2kernel4opu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4opu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4opu':                        'ACK4XI',   # 
           'fetch2kernelsource4opu':                        'ACK4XI',   # 
           'get2kernelinfo4opu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4opu':                   'ACK4XI',   # 
        
           'release2kernel4opu':                            'ACK4XI',   #                                   
           'retain2kernel4opu':                             'ACK4XI',   # 
           'set2kernel4opu':                                'ACK4XI',   # 
           'set2kernelarg4opu':                             'ACK4XI',   #   
           'set2kernelcallback4opu':                        'ACK4XI',   # 
           'trace2kernel4opu':                              'ACK4XI',   # 
           'unload2compiler4opu':                           'ACK4XI',   # 
           # ===
           # PPU
           # ===                                             
           'PPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4ppu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4ppu':                            'ACK4XI',   #   
           'get2kernelarginfo4ppu':                         'ACK4XI',   #        
           'create2kernel4ppu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4ppu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4ppu':           'ACK4XI',   # 
           'delete2kernel4ppu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4ppu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4ppu':                        'ACK4XI',   # 
           'fetch2kernelsource4ppu':                        'ACK4XI',   # 
           'get2kernelinfo4ppu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4ppu':                   'ACK4XI',   # 
        
           'release2kernel4ppu':                            'ACK4XI',   #                                   
           'retain2kernel4ppu':                             'ACK4XI',   # 
           'set2kernel4ppu':                                'ACK4XI',   # 
           'set2kernelarg4ppu':                             'ACK4XI',   #   
           'set2kernelcallback4ppu':                        'ACK4XI',   # 
           'trace2kernel4ppu':                              'ACK4XI',   # 
           'unload2compiler4ppu':                           'ACK4XI',   # 
           # ===
           # QPU
           # ===                                             
           'QPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4qpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4qpu':                            'ACK4XI',   #   
           'get2kernelarginfo4qpu':                         'ACK4XI',   #        
           'create2kernel4qpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4qpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4qpu':           'ACK4XI',   # 
           'delete2kernel4qpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4qpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4qpu':                        'ACK4XI',   # 
           'fetch2kernelsource4qpu':                        'ACK4XI',   # 
           'get2kernelinfo4qpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4qpu':                   'ACK4XI',   # 
         
           'release2kernel4qpu':                            'ACK4XI',   #                                   
           'retain2kernel4qpu':                             'ACK4XI',   # 
           'set2kernel4qpu':                                'ACK4XI',   # 
           'set2kernelarg4qpu':                             'ACK4XI',   #   
           'set2kernelcallback4qpu':                        'ACK4XI',   # 
           'trace2kernel4qpu':                              'ACK4XI',   # 
           'unload2compiler4qpu':                           'ACK4XI',   # 
           # ===
           # RPU
           # ===                                             
           'RPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4rpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4rpu':                            'ACK4XI',   #   
           'get2kernelarginfo4rpu':                         'ACK4XI',   #        
           'create2kernel4rpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4rpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4rpu':           'ACK4XI',   # 
           'delete2kernel4rpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4rpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4rpu':                        'ACK4XI',   # 
           'fetch2kernelsource4rpu':                        'ACK4XI',   # 
           'get2kernelinfo4rpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4rpu':                   'ACK4XI',   # 
     
           'release2kernel4rpu':                            'ACK4XI',   #                                   
           'retain2kernel4rpu':                             'ACK4XI',   # 
           'set2kernel4rpu':                                'ACK4XI',   # 
           'set2kernelarg4rpu':                             'ACK4XI',   #   
           'set2kernelcallback4rpu':                        'ACK4XI',   # 
           'trace2kernel4rpu':                              'ACK4XI',   # 
           'unload2compiler4rpu':                           'ACK4XI',   # 
           # ===
           # SPU
           # ===                                             
           'SPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4spu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4spu':                            'ACK4XI',   #   
           'get2kernelarginfo4spu':                         'ACK4XI',   #        
           'create2kernel4spu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4spu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4spu':           'ACK4XI',   # 
           'delete2kernel4spu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4spu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4spu':                        'ACK4XI',   # 
           'fetch2kernelsource4spu':                        'ACK4XI',   # 
           'get2kernelinfo4spu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4spu':                   'ACK4XI',   # 
          
           'release2kernel4spu':                            'ACK4XI',   #                                   
           'retain2kernel4spu':                             'ACK4XI',   # 
           'set2kernel4spu':                                'ACK4XI',   # 
           'set2kernelarg4spu':                             'ACK4XI',   #   
           'set2kernelcallback4spu':                        'ACK4XI',   # 
           'trace2kernel4spu':                              'ACK4XI',   # 
           'unload2compiler4spu':                           'ACK4XI',   # 
           # ===
           # TPU
           # ===                                             
           'TPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4tpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4tpu':                            'ACK4XI',   #   
           'get2kernelarginfo4tpu':                         'ACK4XI',   #        
           'create2kernel4tpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4tpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4tpu':           'ACK4XI',   # 
           'delete2kernel4tpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4tpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4tpu':                        'ACK4XI',   # 
           'fetch2kernelsource4tpu':                        'ACK4XI',   # 
           'get2kernelinfo4tpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4tpu':                   'ACK4XI',   # 
          
           'release2kernel4tpu':                            'ACK4XI',   #                                   
           'retain2kernel4tpu':                             'ACK4XI',   # 
           'set2kernel4tpu':                                'ACK4XI',   # 
           'set2kernelarg4tpu':                             'ACK4XI',   #   
           'set2kernelcallback4tpu':                        'ACK4XI',   # 
           'trace2kernel4tpu':                              'ACK4XI',   # 
           'unload2compiler4tpu':                           'ACK4XI',   # 
           # ===
           # UPU
           # ===                                             
           'UPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4upu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4upu':                            'ACK4XI',   #   
           'get2kernelarginfo4upu':                         'ACK4XI',   #        
           'create2kernel4upu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4upu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4upu':           'ACK4XI',   # 
           'delete2kernel4upu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4upu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4upu':                        'ACK4XI',   # 
           'fetch2kernelsource4upu':                        'ACK4XI',   # 
           'get2kernelinfo4upu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4upu':                   'ACK4XI',   # 
          
           'release2kernel4upu':                            'ACK4XI',   #                                   
           'retain2kernel4upu':                             'ACK4XI',   # 
           'set2kernel4upu':                                'ACK4XI',   # 
           'set2kernelarg4upu':                             'ACK4XI',   #   
           'set2kernelcallback4upu':                        'ACK4XI',   # 
           'trace2kernel4upu':                              'ACK4XI',   # 
           'unload2compiler4upu':                           'ACK4XI',   # 
           # ===
           # VPU
           # ===                                             
           'VPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4vpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4vpu':                            'ACK4XI',   #   
           'get2kernelarginfo4vpu':                         'ACK4XI',   #        
           'create2kernel4vpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4vpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4vpu':           'ACK4XI',   # 
           'delete2kernel4vpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4vpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4vpu':                        'ACK4XI',   # 
           'fetch2kernelsource4vpu':                        'ACK4XI',   # 
           'get2kernelinfo4vpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4vpu':                   'ACK4XI',   # 
              
           'release2kernel4vpu':                            'ACK4XI',   #                                   
           'retain2kernel4vpu':                             'ACK4XI',   # 
           'set2kernel4vpu':                                'ACK4XI',   # 
           'set2kernelarg4vpu':                             'ACK4XI',   #   
           'set2kernelcallback4vpu':                        'ACK4XI',   # 
           'trace2kernel4vpu':                              'ACK4XI',   # 
           'unload2compiler4vpu':                           'ACK4XI',   # 
           # ===
           # WPU
           # ===                                             
           'WPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4wpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4wpu':                            'ACK4XI',   #   
           'get2kernelarginfo4wpu':                         'ACK4XI',   #        
           'create2kernel4wpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4wpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4wpu':           'ACK4XI',   # 
           'delete2kernel4wpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4wpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4wpu':                        'ACK4XI',   # 
           'fetch2kernelsource4wpu':                        'ACK4XI',   # 
           'get2kernelinfo4wpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4wpu':                   'ACK4XI',   # 
               
           'release2kernel4wpu':                            'ACK4XI',   #                                   
           'retain2kernel4wpu':                             'ACK4XI',   # 
           'set2kernel4wpu':                                'ACK4XI',   # 
           'set2kernelarg4wpu':                             'ACK4XI',   #   
           'set2kernelcallback4wpu':                        'ACK4XI',   # 
           'trace2kernel4wpu':                              'ACK4XI',   # 
           'unload2compiler4wpu':                           'ACK4XI',   # 
           # ===
           # XPU
           # ===                                             
           'XPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4xpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4xpu':                            'ACK4XI',   #   
           'get2kernelarginfo4xpu':                         'ACK4XI',   #        
           'create2kernel4xpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4xpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4xpu':           'ACK4XI',   # 
           'delete2kernel4xpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4xpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4xpu':                        'ACK4XI',   # 
           'fetch2kernelsource4xpu':                        'ACK4XI',   # 
           'get2kernelinfo4xpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4xpu':                   'ACK4XI',   # 
         
           'release2kernel4xpu':                            'ACK4XI',   #                                   
           'retain2kernel4xpu':                             'ACK4XI',   # 
           'set2kernel4xpu':                                'ACK4XI',   # 
           'set2kernelarg4xpu':                             'ACK4XI',   #   
           'set2kernelcallback4xpu':                        'ACK4XI',   # 
           'trace2kernel4xpu':                              'ACK4XI',   # 
           'unload2compiler4xpu':                           'ACK4XI',   # 
           # ===
           # YPU
           # ===                                             
           'YPU2Kernel4Xi':                                 'ACK4XI',   # 
           'add2kernel4ypu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4ypu':                            'ACK4XI',   #   
           'get2kernelarginfo4ypu':                         'ACK4XI',   #        
           'create2kernel4ypu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4ypu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4ypu':           'ACK4XI',   # 
           'delete2kernel4ypu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4ypu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4ypu':                        'ACK4XI',   # 
           'fetch2kernelsource4ypu':                        'ACK4XI',   # 
           'get2kernelinfo4ypu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4ypu':                   'ACK4XI',   # 
          
           'release2kernel4ypu':                            'ACK4XI',   #                                   
           'retain2kernel4ypu':                             'ACK4XI',   # 
           'set2kernel4ypu':                                'ACK4XI',   # 
           'set2kernelarg4ypu':                             'ACK4XI',   #   
           'set2kernelcallback4ypu':                        'ACK4XI',   # 
           'trace2kernel4ypu':                              'ACK4XI',   # 
           'unload2compiler4ypu':                           'ACK4XI',   # 
                                                                                                                                                                                                                                                                                   
           # ===
           # ZPU
           # ===     
           'ZPU2Kernel4Xi':                                 'ACK4XI',   #
           'add2kernel4zpu':                                'ACK4XI',   # (FOCUS 04)   
           'execute2kernel4zpu':                            'ACK4XI',   #   
           'get2kernelarginfo4zpu':                         'ACK4XI',   #        
           'create2kernel4zpu':                             'ACK4XI',   # (FOCUS 07) 
           'create2kernelsinprogram4zpu':                   'ACK4XI',   # 
           'create2kernelwithbuiltinkernels4zpu':           'ACK4XI',   # 
           'delete2kernel4zpu':                             'ACK4XI',   # (FOCUS 09) 
           'delete2kernel4zpu':                             'ACK4XI',   # (FOCUS 05)          
           'fetch2kernelbinary4zpu':                        'ACK4XI',   # 
           'fetch2kernelsource4zpu':                        'ACK4XI',   # 
           'get2kernelinfo4zpu':                            'ACK4XI',   # (FOCUS 06) 
           'get2kernelworkgroupinfo4zpu':                   'ACK4XI',   # 
              
           'release2kernel4zpu':                            'ACK4XI',   #                                   
           'retain2kernel4zpu':                             'ACK4XI',   # 
           'set2kernel4zpu':                                'ACK4XI',   # 
           'set2kernelarg4zpu':                             'ACK4XI',   #   
           'set2kernelcallback4zpu':                        'ACK4XI',   # 
           'trace2kernel4zpu':                              'ACK4XI',   # 
           'unload2compiler4zpu':                           'ACK4XI'    # 
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        trace2scope.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>              


           
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for kernel4xi test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(trace2scope):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Kernel of XI.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Kernel of XI sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(trace2scope, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Kernel of XI.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(trace2scope, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Kernel of XI.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Kernel of XI.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(trace2scope, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "kernel4xi5test" usage = "
# tests kernel4xi
#"> 

# -------------------------------------------------------------------------------------------------    
def kernel4xi5test():
    global trace2scope 
    global KB2PU
    global keys2pu
    global KB2CC
    global keys2cc 
    global KB4Focus   
    global folder2lib4zpu 
    
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE                          
    # ---------------------------------------------------------------------------------------------    
    kernel4xi = {}                                                      # KERNELS
    kerneltrace4xi = {}                                                 # TRACE
    platform2xi = {}                                                     # PLATFORM
    device2xi   = {}                                                     # DEVICE
    context2xi  = {}                                                     # CONTEXT

    # ---------------------------------------------------------------------------------------------
    # START TESTING                          
    # ---------------------------------------------------------------------------------------------    
    print('(Step 1A/700) OF KERNEL4XI5TEST - STARTED ', time4xi())  
    
    try:
        print('FOCUS 01')
        if KB4Focus['create2kernel4xi'] == 'NACK4XI':   
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE KERNEL OBJECT FOR XI                      
            # ---------------------------------------------------------------------------------------------    
            print('(Step 20A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNEL OBJECT FOR XI ', time4xi())      
            try:
                response4create2kernel = create2kernel4xi()                                                                 
                print('(Step 20B/700) OF KERNEL4XI5TEST - CREATED KERNEL OBJECT FOR XI ', time4xi()) 
                # 
            except:
                print('(Step 20Z1/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT FOR XI ', time4xi()) 
            try: 
                keys2response = response4create2kernel.keys()
                for key2response in sorted(keys2response):                                                                                     
                    kernel2pu = response4create2kernel [key2response]
                    keys2kernel = kernel2pu.keys()
                    for key2kernel in sorted(keys2kernel):
                        print(key2response, key2kernel)
                        # APU ACK2RETURN
                        # APU BUFFER
                        # APU CODE2ERROR
                        # APU CODE4BIN
                        # APU CODE4C
                        # APU CODE4CL
                        # APU CODE4CPP
                        # APU CODE4PY
                        # APU CODE4PYC
                        # APU COMMANDQUEUE
                        # APU CONTEXT
                        # APU COUNT2REFERENCE
                        # APU COUNT4BIN
                        # APU COUNT4C
                        # APU COUNT4CL
                        # APU COUNT4CPP
                        # APU COUNT4PY
                        # APU COUNT4PYC
                        # APU DATA2CALLBACK
                        # APU DEVICE
                        # APU DIRECTORY4BIN
                        # APU DIRECTORY4C
                        # APU DIRECTORY4CL
                        # APU DIRECTORY4CPP
                        # APU DIRECTORY4PY
                        # APU DIRECTORY4PYC
                        # APU EVENT
                        # APU FUNCTION
                        # APU FUNCTION2CALLBACK
                        # APU LANGUAGE
                        # APU NACK2RETURN
                        # APU PIPE
                        # APU PLATFORM
                        # APU PROGRAM
                        # APU QUEUE
                        # APU SIZE4BIN
                        # APU SIZE4CPP
                        # APU SIZE4PY
                        # APU SIZE4PYC                        
                        # ...
                        # ZPU SIZE4PYC                        
            except:
                print('(Step 20Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2KERNEL ', response4create2kernel) 
            
            print('ZPU KERNEL DETAILS ')
            try:                                                                                      
                print('FUNCTION2KERNEL: ' , response4create2kernel['ZPU'] ['FUNCTION'])
                # {'.py': {'zpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}
            except:
                print('(Step 20Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4PY = response4create2kernel['ZPU'] ['CODE4PY'].keys()                                                                                      
                print('CODE4PY: ' , keys2CODE4PY)
                # ['folder2lib4zpu + zpu2sampler4xi5test.py']
            except:
                print('(Step 20Z4/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4PYC: ' , response4create2kernel['ZPU'] ['DIRECTORY4PYC'])
                # folder2lib4zpu + __pycache__//
            except:
                print('(Step 20Z5/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4PY: ' , response4create2kernel['ZPU'] ['DIRECTORY4PY'])
                # folder2lib4zpu 
            except:
                print('(Step 20Z6/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4CPP: ' , response4create2kernel['ZPU'] ['DIRECTORY4CPP'])
                # folder2lib4zpu
            except:
                print('(Step 20Z7/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel) 
            
            try:
                keys2CODE4CPP = response4create2kernel['ZPU'] ['CODE4CPP'].keys()                                                                                      
                print('CODE4CPP: ' , keys2CODE4CPP)
                # ['folder2lib4zpu + zpu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z8/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4BIN = response4create2kernel['ZPU'] ['CODE4BIN'].keys()                                                                                      
                print('CODE4BIN: ' , keys2CODE4BIN)
                # ['folder2lib4zpu + bin//zpu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z9/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4PYC = response4create2kernel['ZPU'] ['CODE4PYC'].keys()                                                                                      
                print('CODE4PYC: ' , keys2CODE4PYC)
                # ['folder2lib4zpu + __pycache__//zpu2sampler4xi.cpython-33.pyc'] 
            except:
                print('(Step 20Z10/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4CPP = response4create2kernel['ZPU'] ['SIZE4CPP'].keys()                                                                                      
                print('SIZE4CPP: ' , keys2SIZE4CPP)
                # ['folder2lib4zpu + zpu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z11/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                   
            
            try:
                keys2SIZE4PYC = response4create2kernel['ZPU'] ['SIZE4PYC'].keys()                                                                                      
                print('SIZE4PYC: ' , keys2SIZE4PYC)
                # ['folder2lib4zpu + __pycache__//zpu2sampler4xi.cpython-33.pyc']
            except:
                print('(Step 20Z12/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4BIN = response4create2kernel['ZPU'] ['SIZE4BIN'].keys()                                                                                      
                print('SIZE4BIN: ' , keys2SIZE4BIN)
                # ['folder2lib4zpu + bin//zpu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z13/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                                 
            
            try:
                print('COUNT4PY: ' , response4create2kernel['ZPU'] ['COUNT4PY'])
                # 1
            except:
                print('(Step 20Z14/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('COUNT4BIN: ' , response4create2kernel['ZPU'] ['COUNT4BIN'])
                # 1 
            except:
                print('(Step 20Z15/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('COUNT4CPP: ' , response4create2kernel['ZPU'] ['COUNT4CPP'])
                # 1 
            except:
                print('(Step 20Z16/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4PY = response4create2kernel['ZPU'] ['SIZE4PY'].keys()                                                                                      
                print('SIZE4PY: ' , keys2SIZE4PY)
                # ['folder2lib4zpu + zpu2sampler4xi5test.py']
            except:
                print('(Step 20Z17/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                                 
            
            try:
                print('COUNT4PYC: ' , response4create2kernel['ZPU'] ['COUNT4PYC'])
                # 1
            except:
                print('(Step 20Z18/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4BIN: ' , response4create2kernel['ZPU'] ['DIRECTORY4BIN'])
                # folder2lib4zpu + bin// 
            except:
                print('(Step 20Z19/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                      
        
            
        print('FOCUS 02')
        if KB4Focus['get2kernelinfo4xi'] == 'NACK4XI':
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET KERNEL INFO OF SOME PROCESSING UNITS                      
            # ---------------------------------------------------------------------------------------------    
            print('(Step 30A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL INFO OF SOME PROCESSING UNITS ', time4xi())      
            try:
                task4get2kernelinfo = {}
                task4get2kernelinfo ['GPU'] = 'Yes'
                task4get2kernelinfo ['YPU'] = 'Yes'
            except:
                print('(Step 30Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO OF SOME PROCESSING UNITS ', time4xi()) 
            try:                
                response4get2kernelinfo = get2kernelinfo4xi(task4get2kernelinfo)                                                                 
                print('(Step 30B/700) OF KERNEL4XI5TEST - GOT KERNEL INFO OF SOME PROCESSING UNITS ', time4xi())    
                # 
            except:
                print('(Step 30Z2/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO OF SOME PROCESSING UNITS ', time4xi()) 
            
            print('GPU KERNEL DETAILS ')
            try:                                                                                      
                print('FUNCTION2KERNEL: ' , response4get2kernelinfo['GPU'] ['FUNCTION'])
                # {'.py': {'gpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}
            except:
                print('(Step 20Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4PY = response4get2kernelinfo['GPU'] ['CODE4PY'].keys()                                                                                      
                print('CODE4PY: ' , keys2CODE4PY)
                # ['folder2lib4gpu + gpu2sampler4xi5test.py']
            except:
                print('(Step 20Z4/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4PYC: ' , response4get2kernelinfo['GPU'] ['DIRECTORY4PYC'])
                # folder2lib4gpu + __pycache__//
            except:
                print('(Step 20Z5/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4PY: ' , response4get2kernelinfo['GPU'] ['DIRECTORY4PY'])
                # folder2lib4gpu 
            except:
                print('(Step 20Z6/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4CPP: ' , response4get2kernelinfo['GPU'] ['DIRECTORY4CPP'])
                # folder2lib4gpu
            except:
                print('(Step 20Z7/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo) 
            
            try:
                keys2CODE4CPP = response4get2kernelinfo['GPU'] ['CODE4CPP'].keys()                                                                                      
                print('CODE4CPP: ' , keys2CODE4CPP)
                # ['folder2lib4gpu + gpu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z8/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4BIN = response4get2kernelinfo['GPU'] ['CODE4BIN'].keys()                                                                                      
                print('CODE4BIN: ' , keys2CODE4BIN)
                # ['folder2lib4gpu + bin//gpu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z9/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4PYC = response4get2kernelinfo['GPU'] ['CODE4PYC'].keys()                                                                                      
                print('CODE4PYC: ' , keys2CODE4PYC)
                # ['folder2lib4gpu + __pycache__//gpu2sampler4xi.cpython-33.pyc'] 
            except:
                print('(Step 20Z10/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4CPP = response4get2kernelinfo['GPU'] ['SIZE4CPP'].keys()                                                                                      
                print('SIZE4CPP: ' , keys2SIZE4CPP)
                # ['folder2lib4gpu + gpu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z11/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                   
            
            try:
                keys2SIZE4PYC = response4get2kernelinfo['GPU'] ['SIZE4PYC'].keys()                                                                                      
                print('SIZE4PYC: ' , keys2SIZE4PYC)
                # ['folder2lib4gpu + __pycache__//gpu2sampler4xi.cpython-33.pyc']
            except:
                print('(Step 20Z12/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4BIN = response4get2kernelinfo['GPU'] ['SIZE4BIN'].keys()                                                                                      
                print('SIZE4BIN: ' , keys2SIZE4BIN)
                # ['folder2lib4gpu + bin//gpu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z13/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                                 
            
            try:
                print('COUNT4PY: ' , response4get2kernelinfo['GPU'] ['COUNT4PY'])
                # 1
            except:
                print('(Step 20Z14/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('COUNT4BIN: ' , response4get2kernelinfo['GPU'] ['COUNT4BIN'])
                # 1 
            except:
                print('(Step 20Z15/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('COUNT4CPP: ' , response4get2kernelinfo['GPU'] ['COUNT4CPP'])
                # 1 
            except:
                print('(Step 20Z16/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4PY = response4get2kernelinfo['GPU'] ['SIZE4PY'].keys()                                                                                      
                print('SIZE4PY: ' , keys2SIZE4PY)
                # ['folder2lib4gpu + gpu2sampler4xi5test.py']
            except:
                print('(Step 20Z17/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                                 
            
            try:
                print('COUNT4PYC: ' , response4get2kernelinfo['GPU'] ['COUNT4PYC'])
                # 1
            except:
                print('(Step 20Z18/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4BIN: ' , response4get2kernelinfo['GPU'] ['DIRECTORY4BIN'])
                # folder2lib4gpu + bin// 
            except:
                print('(Step 20Z19/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)     
            
            print('YPU KERNEL DETAILS ')
            try:                                                                                      
                print('FUNCTION2KERNEL: ' , response4get2kernelinfo['YPU'] ['FUNCTION'])
                # {'.py': {'ypu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}
            except:
                print('(Step 20Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4PY = response4get2kernelinfo['YPU'] ['CODE4PY'].keys()                                                                                      
                print('CODE4PY: ' , keys2CODE4PY)
                # ['folder2lib4ypu + ypu2sampler4xi5test.py']
            except:
                print('(Step 20Z4/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4PYC: ' , response4get2kernelinfo['YPU'] ['DIRECTORY4PYC'])
                # folder2lib4ypu + __pycache__//
            except:
                print('(Step 20Z5/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4PY: ' , response4get2kernelinfo['YPU'] ['DIRECTORY4PY'])
                # folder2lib4ypu 
            except:
                print('(Step 20Z6/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4CPP: ' , response4get2kernelinfo['YPU'] ['DIRECTORY4CPP'])
                # folder2lib4ypu
            except:
                print('(Step 20Z7/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo) 
            
            try:
                keys2CODE4CPP = response4get2kernelinfo['YPU'] ['CODE4CPP'].keys()                                                                                      
                print('CODE4CPP: ' , keys2CODE4CPP)
                # ['folder2lib4ypu + ypu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z8/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4BIN = response4get2kernelinfo['YPU'] ['CODE4BIN'].keys()                                                                                      
                print('CODE4BIN: ' , keys2CODE4BIN)
                # ['folder2lib4ypu + bin//ypu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z9/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2CODE4PYC = response4get2kernelinfo['YPU'] ['CODE4PYC'].keys()                                                                                      
                print('CODE4PYC: ' , keys2CODE4PYC)
                # ['folder2lib4ypu + __pycache__//ypu2sampler4xi.cpython-33.pyc'] 
            except:
                print('(Step 20Z10/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4CPP = response4get2kernelinfo['YPU'] ['SIZE4CPP'].keys()                                                                                      
                print('SIZE4CPP: ' , keys2SIZE4CPP)
                # ['folder2lib4ypu + ypu2dummy4xi5test.cpp']
            except:
                print('(Step 20Z11/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                   
            
            try:
                keys2SIZE4PYC = response4get2kernelinfo['YPU'] ['SIZE4PYC'].keys()                                                                                      
                print('SIZE4PYC: ' , keys2SIZE4PYC)
                # ['folder2lib4ypu + __pycache__//ypu2sampler4xi.cpython-33.pyc']
            except:
                print('(Step 20Z12/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4BIN = response4get2kernelinfo['YPU'] ['SIZE4BIN'].keys()                                                                                      
                print('SIZE4BIN: ' , keys2SIZE4BIN)
                # ['folder2lib4ypu + bin//ypu2dummy4xi5test.exe'] 
            except:
                print('(Step 20Z13/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                                 
            
            try:
                print('COUNT4PY: ' , response4get2kernelinfo['YPU'] ['COUNT4PY'])
                # 1
            except:
                print('(Step 20Z14/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('COUNT4BIN: ' , response4get2kernelinfo['YPU'] ['COUNT4BIN'])
                # 1 
            except:
                print('(Step 20Z15/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('COUNT4CPP: ' , response4get2kernelinfo['YPU'] ['COUNT4CPP'])
                # 1 
            except:
                print('(Step 20Z16/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                keys2SIZE4PY = response4get2kernelinfo['YPU'] ['SIZE4PY'].keys()                                                                                      
                print('SIZE4PY: ' , keys2SIZE4PY)
                # ['folder2lib4ypu + ypu2sampler4xi5test.py']
            except:
                print('(Step 20Z17/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                                                 
            
            try:
                print('COUNT4PYC: ' , response4get2kernelinfo['YPU'] ['COUNT4PYC'])
                # 1
            except:
                print('(Step 20Z18/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)
            
            try:
                print('DIRECTORY4BIN: ' , response4get2kernelinfo['YPU'] ['DIRECTORY4BIN'])
                # folder2lib4ypu + bin// 
            except:
                print('(Step 20Z19/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo)                              
 
        print('JATKA')
        print('FOCUS 04')
        if KB4Focus['add2kernel4xi'] == 'NACK4XI':    
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - ADD INTO KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------                      
            print('(Step 50A/700) OF KERNEL4XI5TEST - TRYING TO ADD INTO KERNEL OBJECT ', time4xi())          
            try:
                task4add2kernel = {}
            except:
                print('(Step 50Z1/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
            try:    
                task4add2kernel ['APU'] = {}
            except:
                print('(Step 50Z2/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi()) 
            try:       
                task4add2kernel ['APU'] ['CODE4KERNEL'] = {}
            except:
                print('(Step 50Z3/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())    
            try:    
                task4add2kernel ['APU'] ['CODE4KERNEL'] [folder2lib4apu + 'apu2dummy4xi.py'] = {}
            except:
                print('(Step 50Z4/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())    
            try:    
                task4add2kernel ['APU'] ['CODE4KERNEL'] [folder2lib4apu + 'apu2dummy4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
            except:
                print('(Step 50Z5/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
            try:    
                task4add2kernel ['APU'] ['CODE4KERNEL'] [folder2lib4apu + 'apu2dummy4xi.py'] [2] = '#<program4xi program = "apu2dummy4xi.py" />\n'
            except:
                print('(Step 50Z6/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())    
            try:
                task4add2kernel ['APU'] ['SIZE4SOURCE'] = {}
            except:
                print('(Step 50Z7/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())    
            
            try:
                task4add2kernel ['APU'] ['SIZE4SOURCE'] [folder2lib4apu + 'apu2dummy4xi.py'] = len(task4add2kernel ['APU']  ['CODE4KERNEL'] [folder2lib4apu + 'apu2dummy4xi.py'])
            except:
                print('(Step 50Z8/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi()) 
                   
            try:    
                print('(Step 50B/700) OF KERNEL4XI5TEST - PASSING TO add2kernel4xi TASK4ADD2KERNEL ', task4add2kernel)
                # {'APU': 
                #        {'CODE4KERNEL': {'e://scope4xi//041721//zap//lib//a//apu2dummy4xi.py': {1: '#<profile4xi profile = "33" />\n', 2: '#<program4xi program = "apu2dummy4xi.py" />\n'}}, 
                #         'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2dummy4xi.py': 2}}}

            except:
                print('(Step 50Z9/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
            try:                            
                response4add2kernel = add2kernel4xi(task4add2kernel)
                print('(Step 50C/700) OF KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH FUNCTION ', response4add2kernel)
                #                                                                                   
            except:
                print('(Step 50Z10/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
            try:                                                                                      
                keys2kernel = response4add2kernel.keys()
                for key2kernel in keys2kernel:
                    print('KEY2KERNEL ' , key2kernel)
                    #        
            except:
                print('(Step 50Z11/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel *** ', response4add2kernel)                

                
        print('FOCUS 05')
        if KB4Focus['delete2kernel4xi'] == 'NACK4XI':
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE INSIDE KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------    
            print('(Step 60A/700) OF KERNEL4XI5TEST - TRYING TO DELETE INSIDE KERNEL OBJECT ', time4xi())          
            try:
                task4delete2kernel = {}
    
                task4delete2kernel ['ZPU'] = {}
                task4delete2kernel ['ZPU'] ['CODE4SOURCE'] = {}            
                task4delete2kernel ['ZPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//z//zpu2dummy4xi5test.py'] = 'Yes'

                response4delete2kernel = delete2kernel4xi(task4delete2kernel)
                print('(Step 60B/700) OF KERNEL4XI5TEST - DELETED INSIDE KERNEL OBJECT ', time4xi())
                
            except:
                print('(Step 60Z1/700) OF KERNEL4XI5TEST *** FAILED TO DELETE INSIDE KERNEL OBJECT ', time4xi()) 
            try: 
                keys2response = response4delete2kernel.keys()
                for key2response in sorted(keys2response):                                                                                     
                    print('COUNT4SOURCE: ', response4delete2kernel [key2response] ['COUNT4SOURCE'])
                    print('DIRECTORY4SOURCE: ', response4delete2kernel [key2response] ['DIRECTORY4SOURCE'])
                    print('LANGUAGE4SOURCE: ', response4delete2kernel [key2response] ['LANGUAGE4SOURCE'])
                    print('SIZE4SOURCE: ', response4delete2kernel [key2response] ['SIZE4SOURCE'])
                    keys2source = response4delete2kernel [key2response] ['CODE4SOURCE'].keys()
                    for key2source in keys2source:
                        print('SOURCE: ', key2source)
                        print(response4delete2kernel  [key2response] ['CODE4SOURCE'] [key2source] [1])
 
            # COUNT4SOURCE:  1
                # DIRECTORY4SOURCE:  e://scope4xi//041721//zap//lib//z//
                # LANGUAGE4SOURCE:  Python
                # SIZE4SOURCE:  {'e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py': 1337}
                # SOURCE:  e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py
                # #<profile4xi profile = "11" />
            except:
                print('(Step 60Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2KERNEL ', response4delete2kernel) 
      
        print('FOCUS 06')
        if KB4Focus['get2kernelinfo4xi'] == 'NACK4XI':
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME KERNEL INFO ABOUT KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------    
            print('(Step 70A/700) OF KERNEL4XI5TEST - TRYING TO GET SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())          
            try:
                task4get2kernelinfo = {}
    
                task4get2kernelinfo ['ZPU'] = {}
                task4get2kernelinfo ['ZPU'] ['COUNT4SOURCE'] = 'Yes'           
                task4get2kernelinfo ['ZPU'] ['CODE4SOURCE'] = 'Yes'    
                task4get2kernelinfo ['ZPU'] ['SIZE4SOURCE'] = 'Yes'  
                                          
                response4get2kernelinfo = get2kernelinfo4xi(task4get2kernelinfo)
                print('(Step 70B/700) OF KERNEL4XI5TEST - GOT SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())   
            except:
                print('(Step 70Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())
            try: 
                keys2response = response4get2kernelinfo.keys()
                for key2response in sorted(keys2response):
                    try:                                                                                     
                        print('COUNT4SOURCE: ', response4get2kernelinfo [key2response] ['COUNT4SOURCE'])
                    except:
                        pass
                    try:        
                        print('DIRECTORY4SOURCE: ', response4get2kernelinfo [key2response] ['DIRECTORY4SOURCE'])
                    except:
                        pass
                    try:        
                        print('LANGUAGE4SOURCE: ', response4get2kernelinfo [key2response] ['LANGUAGE4SOURCE'])
                    except:
                        pass
                    try:        
                        print('SIZE4SOURCE: ', response4get2kernelinfo [key2response] ['SIZE4SOURCE'])
                        keys2source = response4get2kernelinfo [key2response] ['CODE4SOURCE'].keys()
                        for key2source in keys2source:
                            print('SOURCE: ', key2source)
                            print(response4get2kernelinfo  [key2response] ['CODE4SOURCE'] [key2source] [1])
                    except:
                        pass
                # COUNT4SOURCE:  1
                # SIZE4SOURCE:  {'e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py': 1337}
                # SOURCE:  e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py
                # #<profile4xi profile = "11" />         
            except:
                print('(Step 70Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo ', response4get2kernelinfo) 
        
        print('FOCUS 07')
        if KB4Focus['create2kernelsinprogram4xi'] == 'NACK4XI':            
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE KERNEL OBJECT WITH BINARY FOR XI                      
            # ---------------------------------------------------------------------------------------------    
            print('(Step 76A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNEL OBJECT WITH BINARY FOR XI ', time4xi())      
            try:
                response4create2pwb = create2kernelsinprogram4xi()                                                                 
                print('(Step 76B/700) OF KERNEL4XI5TEST - CREATED KERNEL OBJECT WITH BINARY FOR XI ', time4xi())
            except:
                print('(Step 76Z1/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT WITH BINARY FOR XI ', time4xi()) 
            try: 
                keys2response = response4create2pwb.keys()
                for key2response in sorted(keys2response):                                                                                     
                    print('COUNT4BINARY: ', response4create2pwb [key2response] ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY: ', response4create2pwb [key2response] ['DIRECTORY4BINARY'])
                    print('LANGUAGE4BINARY: ', response4create2pwb [key2response] ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY: ', response4create2pwb [key2response] ['SIZE4BINARY'])
                    keys2binary = response4create2pwb [key2response] ['CODE4BINARY'].keys()
                    for key2binary in keys2binary:
                        print('BINARY: ', key2binary)
                        print(response4create2pwb  [key2response] ['CODE4BINARY'] [key2binary] [1])
            # COUNT4BINARY:  1
            # DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//a//__pycache__//
            # LANGUAGE4BINARY:  Python
            # SIZE4BINARY:  {'e://scope4xi//041721//zap//lib//a//__pycache__//apu2image4xi.cpython-33.pyc': 1006}
            # BINARY:  e://scope4xi//041721//zap//lib//a//__pycache__//apu2image4xi.cpython-33.pyc
            # b'l\x0c\r\n'
            # ...
            # COUNT4BINARY:  1
            # DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//z//__pycache__//
            # LANGUAGE4BINARY:  Python
            # SIZE4BINARY:  {'e://scope4xi//041721//zap//lib//z//__pycache__//zpu2image4xi.cpython-33.pyc': 1010}
            # BINARY:  e://scope4xi//041721//zap//lib//z//__pycache__//zpu2image4xi.cpython-33.pyc
            # b'l\x0c\r\n'                              
            except:
                print('(Step 76Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2KERNEL ', response4create2pwb) 
                 
             
        print('FOCUS 08')
        if KB4Focus['add2kernel4xi'] == 'NACK4XI':     
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - ADD BINARY INTO KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------                      
            print('(Step 80A/700) OF KERNEL4XI5TEST - TRYING TO ADD BINARY INTO KERNEL OBJECT ', time4xi())          
            try:
                task4add2pwb = {}
                key4kernelbinary2add = 'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'
                task4add2pwb ['GPU'] = {}
                task4add2pwb ['GPU'] ['CODE4BINARY'] = {}            
                task4add2pwb ['GPU'] ['CODE4BINARY'] [key4kernelbinary2add] = {}
                task4add2pwb ['GPU'] ['CODE4BINARY'] [key4kernelbinary2add] [1] = b'l\x0c\r\n'
                task4add2pwb ['GPU'] ['CODE4BINARY'] [key4kernelbinary2add] [2] = b'l\x0c\z\n'

                task4add2pwb ['GPU'] ['SIZE4BINARY'] = {}
                task4add2pwb ['GPU'] ['SIZE4BINARY'] [key4kernelbinary2add] = len(task4add2pwb ['GPU'] ['CODE4BINARY'] [key4kernelbinary2add]) 
                                 
                response4add2kernel = add2kernel4xi(task4add2pwb)
                
                print('(Step 80B/700) OF KERNEL4XI5TEST - ADDED BINARY INTO KERNEL OBJECT ', response4add2kernel)
                #                                                                       
            except:
                print('(Step 80Z2/700) OF KERNEL4XI5TEST *** FAILED TO ADD BINARY INTO KERNEL OBJECT ', time4xi())
                #         
            try: 
                keys2response = response4add2kernel.keys()
                for key2response in sorted(keys2response):                                                                                     
                    print('COUNT4BINARY: ', response4add2kernel [key2response] ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY: ', response4add2kernel [key2response] ['DIRECTORY4BINARY'])
                    print('LANGUAGE4BINARY: ', response4add2kernel [key2response] ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY: ', response4add2kernel [key2response] ['SIZE4BINARY'])
                    keys2binary = response4add2kernel [key2response] ['CODE4BINARY'].keys()
                    for key2binary in keys2binary:
                        print('BINARY: ', key2binary)
                        print(response4add2kernel  [key2response] ['CODE4BINARY'] [key2binary] [1])
            # COUNT4BINARY:  2
            # DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//
            # LANGUAGE4BINARY:  Python
            # SIZE4BINARY:  {'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc': 1010, 'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc': 2}
            # BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc
            # b'l\x0c\r\n'
            # BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc
            # b'l\x0c\r\n'                            
            except:
                print('(Step 80Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2KERNEL ', response4add2kernel) 
            
        print('FOCUS 09')
        if KB4Focus['delete2kernel4xi'] == 'NACK4XI':                                   
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE BINARY INTO KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------                      
            print('(Step 80A/700) OF KERNEL4XI5TEST - TRYING TO DELETE BINARY INTO KERNEL OBJECT ', time4xi())          
            try:
                task4delete2pwb = {}
                key4kernelbinary2delete = 'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'
                task4delete2pwb ['GPU'] = {}
                task4delete2pwb ['GPU'] ['CODE4BINARY'] = {}            
                task4delete2pwb ['GPU'] ['CODE4BINARY'] [key4kernelbinary2delete] = 'Yes'
                              
                response4delete2kernel = delete2kernel4xi(task4delete2pwb)
                print('(Step 80B/700) OF KERNEL4XI5TEST - DELETED BINARY IN KERNEL OBJECT ', response4delete2kernel) 
                #                                                                       
            except:
                print('(Step 80Z2/700) OF KERNEL4XI5TEST *** FAILED TO DELETE BINARY INTO KERNEL OBJECT ', time4xi())
                #         
            try: 
                keys2response = response4delete2kernel.keys()
                for key2response in sorted(keys2response):                                                                                     
                    print('COUNT4BINARY: ', response4delete2kernel [key2response] ['COUNT4BINARY'])
                    print('DIRECTORY4BINARY: ', response4delete2kernel [key2response] ['DIRECTORY4BINARY'])
                    print('LANGUAGE4BINARY: ', response4delete2kernel [key2response] ['LANGUAGE4BINARY'])
                    print('SIZE4BINARY: ', response4delete2kernel [key2response] ['SIZE4BINARY'])
                    keys2binary = response4delete2kernel [key2response] ['CODE4BINARY'].keys()
                    for key2binary in keys2binary:
                        print('BINARY: ', key2binary)
                        print(response4delete2kernel  [key2response] ['CODE4BINARY'] [key2binary] [1])
            # COUNT4BINARY:  1
            # DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//
            # LANGUAGE4BINARY:  Python
            # SIZE4BINARY:  {'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc': 1010}
            # BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc
            # b'l\x0c\r\n'                           
            except:
                print('(Step 80Z3/700) OF KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4CREATE2KERNEL ', response4delete2kernel) 
             
        print('FOCUS 10')
        if KB4Focus['get2kernelinfo4xi'] == 'NACK4XI':           
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT              
            # ---------------------------------------------------------------------------------------------    
            print('(Step 100A/700) OF KERNEL4XI5TEST - TRYING TO GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())          
            try:
                task4get2kernelinfo = {}
    
                task4get2kernelinfo ['GPU'] = {}
                task4get2kernelinfo ['GPU'] ['COUNT4BINARY'] = 'Yes'           
                task4get2kernelinfo ['GPU'] ['CODE4BINARY'] = 'Yes'    
                task4get2kernelinfo ['GPU'] ['SIZE4BINARY'] = 'Yes'  
                                            
                response4get2kernelinfo = get2kernelinfo4xi(task4get2kernelinfo)
            except:
                print('(Step 100Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())
            try:                                                                                      
                keys2response = response4get2kernelinfo.keys()
                for key2response in sorted(keys2response):
                    try:                                                                                     
                        print('COUNT4BINARY: ', response4get2kernelinfo [key2response] ['COUNT4BINARY'])
                    except:
                        pass
                    try:        
                        print('DIRECTORY4BINARY: ', response4get2kernelinfo [key2response] ['DIRECTORY4BINARY'])
                    except:
                        pass
                    try:        
                        print('LANGUAGE4BINARY: ', response4get2kernelinfo [key2response] ['LANGUAGE4BINARY'])
                    except:
                        pass
                    try:        
                        print('SIZE4BINARY: ', response4get2kernelinfo [key2response] ['SIZE4BINARY'])
                        keys2binary = response4get2kernelinfo [key2response] ['CODE4BINARY'].keys()
                        for key2binary in keys2binary:
                            print('BINARY: ', key2binary)
                            print(response4get2kernelinfo  [key2response] ['CODE4BINARY'] [key2binary] [1])
                    except:
                        pass
            # COUNT4BINARY:  1
            # SIZE4BINARY:  {'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc': 1010}
            # BINARY:  e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc
            # b'l\x0c\r\n'                        
            except:
                print('(Step 100Z2/700) OF KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())

        print('FOCUS 12')
        if KB4Focus['set2kernel4xi'] == 'NACK4XI':                   
            # ---------------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - SET KERNEL WITH FUNCTION TO ALL PROCESSING UNITS - ALL ATTRIBUTES                         
            # ---------------------------------------------------------------------------------------------------    
            #   
            print('(Step 110A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL WITH FUNCTION TO ALL PROCESSING UNITS ', time4xi())    
        
            KB2setkernel = {}
            KB2setkernel ['APU'] = {}
            KB2setkernel ['BPU'] = {}
            KB2setkernel ['CPU'] = {}
            KB2setkernel ['DPU'] = {}
            KB2setkernel ['EPU'] = {}
            KB2setkernel ['FPU'] = {}
            KB2setkernel ['GPU'] = {}
            KB2setkernel ['HPU'] = {}
            KB2setkernel ['IPU'] = {}
            KB2setkernel ['JPU'] = {}
            KB2setkernel ['KPU'] = {}
            KB2setkernel ['LPU'] = {}
            KB2setkernel ['MPU'] = {}
            KB2setkernel ['NPU'] = {}
            KB2setkernel ['OPU'] = {}
            KB2setkernel ['PPU'] = {}
            KB2setkernel ['QPU'] = {}
            KB2setkernel ['RPU'] = {}
            KB2setkernel ['SPU'] = {}
            KB2setkernel ['TPU'] = {}
            KB2setkernel ['UPU'] = {}
            KB2setkernel ['VPU'] = {}
            KB2setkernel ['WPU'] = {}
            KB2setkernel ['XPU'] = {}
            KB2setkernel ['YPU'] = {}
            KB2setkernel ['ZPU'] = {}
            keys2setkernel = KB2setkernel.keys()
            
            task4set2kernel = {} 
        
            # ---------------------------------------------------------------------------------------------
            # (110A) GET PLATFORM IDs
            # ---------------------------------------------------------------------------------------------    
            print('(Step 110A1/700) OF KERNEL4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
            try:
                platform2xi = get2platformids4xi()
                print('(Step 110A2/33) OF KERNEL4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                # 
                 
            except:
                print('(Step 110AZ/33) OF KERNEL4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
        
            # ---------------------------------------------------------------------------------------------
            # (110B) INITIALIZE XI DEVICE                       
            # ---------------------------------------------------------------------------------------------    
            print('(Step 110B1/33) OF KERNEL4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
            try:
                device2xi = init2device4xi()                                                                                
                keys2device = device2xi.keys()
                for key2device in sorted(keys2device):
                    print(key2device, device2xi[key2device])
                    # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
                    # ...
                    # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
            except:
                print('(Step 110BZ/33) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())  
                    
                
            # ---------------------------------------------------------------------------------------------
            # (110C) CREATE XI CONTEXT                  
            # ---------------------------------------------------------------------------------------------    
            print('(Step 110C1/700) OF KERNEL4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
            try:
                context2xi = create2context4xi()                                                                            
                keys2context = context2xi.keys()
                for key2context in sorted(keys2context):
                    print(key2context, device2xi[key2context])
                    # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
                    # ...
                    # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...   
            except:
                print('(Step 110CZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
                
                    
            # ---------------------------------------------------------------------------------------------
            # (110D) CREATE XI COMMANDQUEUE                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 110D1/700) OF KERNEL4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
            try:
                queue4command = create2commandqueue4xi()                                                                            
                keys2commandqueue = queue4command.keys()
                for key2commandqueue in sorted(keys2commandqueue):
                    print(key2commandqueue, queue4command[key2commandqueue])
                    # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                    # ...
                    # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                      
            except:
                print('(Step 110DZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())         
            
            # -------------------------------------------------------------------------------------------------    
            # (120) INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 120A/700) OF KERNEL4XI5TEST - TRYING TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):
                    task4set2kernel [key2setkernel] = {}
                    print(key2setkernel, task4set2kernel [key2setkernel])
                    # 
                    
            except:
                print('(Step 120Z/700) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                            
            # -------------------------------------------------------------------------------------------------    
            # (120) SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 120A/700) OF KERNEL4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):
                    task4set2kernel [key2setkernel] ['CONTEXT'] = context2xi [key2setkernel] 
                    print(key2setkernel, ' CONTEXT: ', task4set2kernel [key2setkernel] ['CONTEXT'])
                    # 
                         
            except:
                print('(Step 120Z/700) OF KERNEL4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi()) 
                
            # -------------------------------------------------------------------------------------------------    
            # (130) SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 130A/700) OF KERNEL4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['DEVICE'] = device2xi [key2setkernel] 
                    print(key2setkernel, 'DEVICE:' , task4set2kernel [key2setkernel] ['DEVICE'])
                    # 
                     
            except:
                print('(Step 130Z/700) OF KERNEL4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
        
                
            # -------------------------------------------------------------------------------------------------    
            # (140) SET ERROR CODE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 140A/700) OF KERNEL4XI5TEST - TRYING TO SET ERROR CODE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['CODE2ERROR'] = 0  
                    print(key2setkernel, ' CODE2ERROR: ', task4set2kernel [key2setkernel] ['CODE2ERROR'])
                    # 
                     
            except:
                print('(Step 140Z/700) OF KERNEL4XI5TEST *** FAILED TO SET ERROR CODE  OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
        
                
            # -------------------------------------------------------------------------------------------------    
            # (150) SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 150A/700) OF KERNEL4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['QUEUE'] = Queue4Xi()
                    print(key2setkernel, ' QUEUE: ', task4set2kernel [key2setkernel] ['QUEUE'])
                    # 
                     
            except:
                print('(Step 150Z/700) OF KERNEL4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                        
                
            # -------------------------------------------------------------------------------------------------    
            # (160) SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 160A/700) OF KERNEL4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel  [key2setkernel] ['PIPE'] = Pipe4Xi() 
                    print(key2setkernel, ' PIPE: ', task4set2kernel  [key2setkernel] ['PIPE']) 
                    # 
                    
            except:
                print('(Step 160Z/700) OF KERNEL4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                
                
            # -------------------------------------------------------------------------------------------------    
            # (170) SET COMMAND QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 170A/700) OF KERNEL4XI5TEST - TRYING TO SET COMMAND QUEUE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):              
                    task4set2kernel  [key2setkernel] ['COMMANDQUEUE'] = queue4command [key2setkernel]
                    print(key2setkernel, ' COMMANDQUEUE: ', task4set2kernel  [key2setkernel] ['COMMANDQUEUE']) 
                    #  
                     
            except:
                print('(Step 160Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                
                                                                    
                
            # ---------------------------------------------------------------------------------------------
            # (180) FINALLY SET KERNEL AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
            # ---------------------------------------------------------------------------------------------          
            response4setkernel = {} 
            print('(Step 180A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL4XI ', time4xi())   
            try:                               
                response4setkernel = set2kernel4xi(task4set2kernel)                                                                                                         
                                                                                              
                print('(Step 180B/700) OF KERNEL4XI5TEST - SET KERNEL4XI ', time4xi())
                keys2response = response4setkernel.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4setkernel[key2response])
                    # APU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2sampler4xi5test.py': 1337} ...
                    #
                    # ZPU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py': 1337} ...
            except:
                print('(Step 180Z/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL4XI *** ', time4xi())  
                #  
                   
        print('FOCUS 14')
        if KB4Focus['set2kernelarg4xi'] == 'NACK4XI':                   
            # ---------------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - SET KERNEL BINARY WITH FUNCTION TO ALL PROCESSING UNITS - ALL ATTRIBUTES                         
            # ---------------------------------------------------------------------------------------------------    
            #   
            print('(Step 210A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL BINARY WITH FUNCTION TO ALL PROCESSING UNITS ', time4xi())    
        
            KB2setkernel = {}
            KB2setkernel ['APU'] = {}
            KB2setkernel ['BPU'] = {}
            KB2setkernel ['CPU'] = {}
            KB2setkernel ['DPU'] = {}
            KB2setkernel ['EPU'] = {}
            KB2setkernel ['FPU'] = {}
            KB2setkernel ['GPU'] = {}
            KB2setkernel ['HPU'] = {}
            KB2setkernel ['IPU'] = {}
            KB2setkernel ['JPU'] = {}
            KB2setkernel ['KPU'] = {}
            KB2setkernel ['LPU'] = {}
            KB2setkernel ['MPU'] = {}
            KB2setkernel ['NPU'] = {}
            KB2setkernel ['OPU'] = {}
            KB2setkernel ['PPU'] = {}
            KB2setkernel ['QPU'] = {}
            KB2setkernel ['RPU'] = {}
            KB2setkernel ['SPU'] = {}
            KB2setkernel ['TPU'] = {}
            KB2setkernel ['UPU'] = {}
            KB2setkernel ['VPU'] = {}
            KB2setkernel ['WPU'] = {}
            KB2setkernel ['XPU'] = {}
            KB2setkernel ['YPU'] = {}
            KB2setkernel ['ZPU'] = {}
            keys2setkernel = KB2setkernel.keys()
            
            task4set2kernel = {} 
        
            # ---------------------------------------------------------------------------------------------
            # (210A) GET PLATFORM IDs
            # ---------------------------------------------------------------------------------------------    
            print('(Step 210A1/700) OF KERNEL4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
            try:
                platform2xi = get2platformids4xi()
                print('(Step 210A2/33) OF KERNEL4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                # 
                 
            except:
                print('(Step 210AZ/33) OF KERNEL4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
        
            # ---------------------------------------------------------------------------------------------
            # (210B) INITIALIZE XI DEVICE                       
            # ---------------------------------------------------------------------------------------------    
            print('(Step 210B1/33) OF KERNEL4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
            try:
                device2xi = init2device4xi()                                                                                
                keys2device = device2xi.keys()
                for key2device in sorted(keys2device):
                    print(key2device, device2xi[key2device])
                    # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
                    # ...
                    # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
            except:
                print('(Step 210BZ/33) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())  
                    
                
            # ---------------------------------------------------------------------------------------------
            # (210C) CREATE XI CONTEXT                  
            # ---------------------------------------------------------------------------------------------    
            print('(Step 210C1/700) OF KERNEL4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
            try:
                context2xi = create2context4xi()                                                                            
                keys2context = context2xi.keys()
                for key2context in sorted(keys2context):
                    print(key2context, device2xi[key2context])
                    # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
                    # ...
                    # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...   
            except:
                print('(Step 210CZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
                
                    
            # ---------------------------------------------------------------------------------------------
            # (210D) CREATE XI COMMANDQUEUE                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 210D1/700) OF KERNEL4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
            try:
                queue4command = create2commandqueue4xi()                                                                            
                keys2commandqueue = queue4command.keys()
                for key2commandqueue in sorted(keys2commandqueue):
                    print(key2commandqueue, queue4command[key2commandqueue])
                    # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                    # ...
                    # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                      
            except:
                print('(Step 210DZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())         
            
            # -------------------------------------------------------------------------------------------------    
            # (220) INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 220A/700) OF KERNEL4XI5TEST - TRYING TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):
                    task4set2kernel [key2setkernel] = {}
                    print(key2setkernel, task4set2kernel [key2setkernel])
                    # 
                    
            except:
                print('(Step 220Z/700) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                            
            # -------------------------------------------------------------------------------------------------    
            # (220) SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 220A/700) OF KERNEL4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):
                    task4set2kernel [key2setkernel] ['CONTEXT'] = context2xi [key2setkernel] 
                    print(key2setkernel, ' CONTEXT: ', task4set2kernel [key2setkernel] ['CONTEXT'])
                    # 
                         
            except:
                print('(Step 220Z/700) OF KERNEL4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi()) 
                
            # -------------------------------------------------------------------------------------------------    
            # (230) SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 230A/700) OF KERNEL4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['DEVICE'] = device2xi [key2setkernel] 
                    print(key2setkernel, 'DEVICE:' , task4set2kernel [key2setkernel] ['DEVICE'])
                    # 
                     
            except:
                print('(Step 230Z/700) OF KERNEL4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
        
                
            # -------------------------------------------------------------------------------------------------    
            # (240) SET ERROR CODE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 240A/700) OF KERNEL4XI5TEST - TRYING TO SET PROPERTIES FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['CODE2ERROR'] = 0  
                    print(key2setkernel, ' CODE2ERROR: ', task4set2kernel [key2setkernel] ['CODE2ERROR'])
                    # 
                     
            except:
                print('(Step 240Z/700) OF KERNEL4XI5TEST *** FAILED TO SET PROPERTIES OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
        
                
            # -------------------------------------------------------------------------------------------------    
            # (250) SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 250A/700) OF KERNEL4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel [key2setkernel] ['QUEUE'] = Queue4Xi()
                    print(key2setkernel, ' QUEUE: ', task4set2kernel [key2setkernel] ['QUEUE'])
                    # 
                     
            except:
                print('(Step 250Z/700) OF KERNEL4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                        
                
            # -------------------------------------------------------------------------------------------------    
            # (260) SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 260A/700) OF KERNEL4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):        
                    task4set2kernel  [key2setkernel] ['PIPE'] = Pipe4Xi() 
                    print(key2setkernel, ' PIPE: ', task4set2kernel  [key2setkernel] ['PIPE']) 
                    # 
                    
            except:
                print('(Step 260Z/700) OF KERNEL4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                
                
            # -------------------------------------------------------------------------------------------------    
            # (270) SET COMMAND QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
            # -------------------------------------------------------------------------------------------------          
            print('(Step 270A/700) OF KERNEL4XI5TEST - TRYING TO SET COMMAND QUEUE FOR PROCESSING UNITS ', time4xi())
            try:
                for key2setkernel in sorted(keys2setkernel):              
                    task4set2kernel  [key2setkernel] ['COMMANDQUEUE'] = queue4command [key2setkernel]
                    print(key2setkernel, ' COMMANDQUEUE: ', task4set2kernel  [key2setkernel] ['COMMANDQUEUE']) 
                    #  
                     
            except:
                print('(Step 260Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                
                
            # -------------------------------------------------------------------------------------------------    
            # (272) SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY            
            # -------------------------------------------------------------------------------------------------          
            print('(Step 272A/700) OF KERNEL4XI5TEST - TRYING TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())
            alpha2set = {}
            alpha2set['a'] = 'APU'
            alpha2set['b'] = 'BPU'
            alpha2set['c'] = 'CPU'
            alpha2set['d'] = 'DPU'
            alpha2set['e'] = 'EPU'
            alpha2set['f'] = 'FPU'
            alpha2set['g'] = 'GPU'
            alpha2set['h'] = 'HPU'
            alpha2set['i'] = 'IPU'
            alpha2set['j'] = 'JPU'
            alpha2set['k'] = 'KPU'
            alpha2set['l'] = 'LPU'
            alpha2set['m'] = 'MPU'
            alpha2set['n'] = 'NPU'
            alpha2set['o'] = 'OPU'
            alpha2set['p'] = 'PPU'
            alpha2set['q'] = 'QPU'
            alpha2set['r'] = 'RPU'
            alpha2set['s'] = 'SPU'
            alpha2set['t'] = 'TPU'
            alpha2set['u'] = 'UPU'
            alpha2set['v'] = 'VPU'
            alpha2set['w'] = 'WPU'
            alpha2set['x'] = 'XPU'
            alpha2set['y'] = 'YPU'
            alpha2set['z'] = 'ZPU'
            print('(Step 272B/700) OF KERNEL4XI5TEST - alpha2set ', alpha2set)
            # {'a': 'APU', 'c': 'CPU', 'b': 'BPU', 'e': 'EPU', 'd': 'DPU', 'g': 'GPU' ....
            try:
                keys2alpha      = alpha2set.keys()
                print('(Step 272C/700) OF KERNEL4XI5TEST - keys2alpha ', keys2alpha)
                # dict_keys(['a', 'c', 'b', 'e', 'd', 'g', 'f', 'i', 'h', 'k', 'j', 'm', 'l', 'o', 'n', 'q', 'p', 's', 'r', 'u', 't', 'w', 'v', 'y', 'x', 'z'])
                language2binary = 'Python'
                print('(Step 272D/700) OF KERNEL4XI5TEST - language2binary ', language2binary)
                # Python
                size2binary     = 1
                print('(Step 272E/700) OF KERNEL4XI5TEST - size2binary ', size2binary)
                # 1
                lib2set         = 'e://scope4xi//041721//zap//lib//'
                print('(Step 272F/700) OF KERNEL4XI5TEST - lib2set ', lib2set)
                # e://scope4xi//041721//zap//lib//
                cache2set       = '//__pycache__//'
                print('(Step 272G/700) OF KERNEL4XI5TEST - cache2set ', cache2set)
                # //__pycache__//
                kb2set = {}
            except:
                print('(Step 272Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())
            try:                    
                for key2alpha in sorted(keys2alpha):                                                                # a,b,c ....
                    key2pu = alpha2set[key2alpha]                                                                   # APU, BPU, CPU ...
                    print('(Step 272H/700) OF KERNEL4XI5TEST - key2pu ', key2pu)
                    # APU
                    
                    kb2set[key2pu]                       = {}
                    directory2binary                     = lib2set + key2alpha + cache2set
                    print('(Step 272I/700) OF KERNEL4XI5TEST - directory2binary ', directory2binary)
                    # e://scope4xi//041721//zap//lib//a//__pycache__//
                    
                    kb2set [key2pu] ['LANGUAGE4BINARY']  = language2binary
                    
                    kb2set [key2pu] ['DIRECTORY4BINARY'] = directory2binary
                    
                    key2binary = lib2set + key2alpha + cache2set + key2alpha + 'pu2sampler4xi.cpython-33.pyc'
                    print('(Step 272I/700) OF KERNEL4XI5TEST - key2binary ', key2binary)
                    # e://scope4xi//041721//zap//lib//a//__pycache__//apu2sampler4xi.cpython-33.pyc
                    
                    kb2set [key2pu] ['CODE4BINARY']     = {}
                    kb2set [key2pu] ['CODE4BINARY'] [1] = b'l\x0c\r\n'
                    print('(Step 272K/700) OF KERNEL4XI5TEST - CODE4BINARY ', kb2set [key2pu] ['CODE4BINARY'])
                    # {1: b'l\x0c\r\n'}
                    kb2set [key2pu] ['SIZE4BINARY']     = len(kb2set [key2pu] ['CODE4BINARY']) 
                    print('(Step 272K/700) OF KERNEL4XI5TEST - SIZE4BINARY ', kb2set [key2pu] ['SIZE4BINARY'])
                    # 1
                    # key2pu  ZPU
                    # directory2binary  e://scope4xi//041721//zap//lib//z//__pycache__//
                    # key2binary  e://scope4xi//041721//zap//lib//z//__pycache__//zpu2sampler4xi.cpython-33.pyc
                    # CODE4BINARY  {1: b'l\x0c\r\n'}
                    # SIZE4BINARY  1                    
            except:
                print('(Step 272Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())            
            
            print('(Step 272L/700) OF KERNEL4XI5TEST - KEYS OF kb2set ', kb2set.keys())  
            # dict_keys(['DPU', 'EPU', 'BPU', 'CPU', 'VPU', 'RPU', 'WPU', 'SPU', 'PPU', 'QPU', 'KPU', 'YPU', 'LPU', 'ZPU', 'HPU', 'FPU', 'TPU', 'GPU', 'UPU', 'XPU', 'OPU', 'APU', 'MPU', 'IPU', 'NPU', 'JPU'])

            print('(Step 272M/700) OF KERNEL4XI5TEST - kb2set ', kb2set) 
            # {'DPU': {'CODE4BINARY': {1: b'l\x0c\r\n'},
            #  'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//d//__pycache__//',
            #  'SIZE4BINARY': 1,
            #  'LANGUAGE4BINARY': 'Python'}, 
            #  'EPU': {'CODE4BINARY': {1: b'l\x0c\r\n'},
            #  'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//e//__pycache__//',
            #  'SIZE4BINARY': 1,
            #  'LANGUAGE4BINARY': 'Python'},
            #  
            # ...
            try:
                for key2setkernel in sorted(keys2setkernel):
                    
                    print('KEY2SETKERNEL ', key2setkernel) 
                    task4set2kernel  [key2setkernel] ['LANGUAGE4BINARY'] = kb2set [key2setkernel] ['LANGUAGE4BINARY']
                    print(key2setkernel, ' LANGUAGE4BINARY: ', task4set2kernel  [key2setkernel] ['LANGUAGE4BINARY']) 
                    task4set2kernel  [key2setkernel] ['DIRECTORY4BINARY'] = kb2set [key2setkernel] ['DIRECTORY4BINARY']
                    print(key2setkernel, ' DIRECTORY4BINARY: ', task4set2kernel  [key2setkernel] ['DIRECTORY4BINARY']) 
                    task4set2kernel  [key2setkernel] ['CODE4BINARY'] = kb2set [key2setkernel] ['CODE4BINARY']
                    print(key2setkernel, ' CODE4BINARY: ', task4set2kernel  [key2setkernel] ['CODE4BINARY']) 
                    task4set2kernel  [key2setkernel] ['SIZE4BINARY'] = kb2set [key2setkernel] ['SIZE4BINARY']
                    print(key2setkernel, ' SIZE4BINARY: ', task4set2kernel  [key2setkernel] ['SIZE4BINARY']) 
            # KEY2SETKERNEL  APU
            # APU  LANGUAGE4BINARY:  Python
            # APU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//a//__pycache__//
            # APU  CODE4BINARY:  {1: b'l\x0c\r\n'}
            # APU  SIZE4BINARY:  1
            # ...
            # KEY2SETKERNEL  ZPU
            # ZPU  LANGUAGE4BINARY:  Python
            # ZPU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//z//__pycache__//
            # ZPU  CODE4BINARY:  {1: b'l\x0c\r\n'}
            # ZPU  SIZE4BINARY:  1
            #                                         
            except:
                print('(Step 272Z3/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())
                
            # ---------------------------------------------------------------------------------------------
            # (280) FINALLY SET KERNEL AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
            # ---------------------------------------------------------------------------------------------          
            response4setkernel = {} 
            print('(Step 280A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL4XI WITH BINARY', time4xi())   
            try:                               
                response4setkernel = set2kernelarg4xi(task4set2kernel)
                print('(Step 280B/700) OF KERNEL4XI5TEST - SET KERNEL4XI response4setkernel ', time4xi())                                                                                                     
            except:
                print('(Step 280Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL4XI WITH BINARY*** ', time4xi()) 
                
            try:                                                                                              
                keys2response = response4setkernel.keys()
                for key2response in sorted(keys2response):
                    try:
                        print(key2response, 'LANGUAGE4BINARY : ', response4setkernel[key2response]['LANGUAGE4BINARY'])
                    except:
                        pass
                    try:
                        print(key2response, 'DIRECTORY4BINARY : ', response4setkernel[key2response]['DIRECTORY4BINARY'])
                    except:
                        pass                            
                    try:
                        print(key2response, 'CODE4BINARY : ', response4setkernel[key2response]['CODE4BINARY'])
                    except:
                        pass
                    try:
                        print(key2response, 'SIZE4BINARY : ', response4setkernel[key2response]['SIZE4BINARY'])
                    except:
                        pass 
            # APU LANGUAGE4BINARY :  Python
            # APU DIRECTORY4BINARY :  e://scope4xi//041721//zap//lib//a//__pycache__//
            # APU CODE4BINARY :  {1: b'l\x0c\r\n'}
            # APU SIZE4BINARY :  1
            # ...
            # ZPU LANGUAGE4BINARY :  Python
            # ZPU DIRECTORY4BINARY :  e://scope4xi//041721//zap//lib//z//__pycache__//
            # ZPU CODE4BINARY :  {1: b'l\x0c\r\n'}
            # ZPU SIZE4BINARY :  1                                                                   
            except:
                print('(Step 280Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4setkernel ', response4setkernel)  
        

        print('FOCUS 15')
        if KB4Focus['release2kernel4xi'] == 'NACK4XI':                      
            # ---------------------------------------------------------------------------------------------
            # (290) REFERENCE COUNT FOR PROCESSING UNITS RELEASED BY DECREMENTING COUNT WITH 1             
            # ---------------------------------------------------------------------------------------------    
            task4release2kernel  = {}
            task4release2kernel ['APU']  = {}
            task4release2kernel ['APU'] ['COUNT2REFERENCE'] = 1
            task4release2kernel ['GPU']  = {}
            task4release2kernel ['GPU'] ['COUNT2REFERENCE'] = 1        
            task4release2kernel ['ZPU']  = {}
            task4release2kernel ['ZPU'] ['COUNT2REFERENCE'] = 1     
            response4release2kernel = {}    
               
            print('(Step 290A/700) OF KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF XI DEVICE ', time4xi())    
            # 
            try:                               
                response4releasekernel = release2kernel4xi(task4release2kernel)
                print('(Step 290B/700) OF KERNEL4XI5TEST - RELEASED KERNEL OF XI DEVICE ', response4releasekernel)                                                                                             
            except:
                print('(Step 290Z1/700) OF KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF XI DEVICE ', time4xi())
            try:                
                     
                keys2response = response4releasekernel.keys()
                for key2response in sorted(keys2response):
                    print('KEY2RESPONSE ', key2response)
                    kb2detail = response4releasekernel[key2response]
                    keys2detail = kb2detail.keys()
                    for key2detail in sorted(keys2detail):
                        print('KEY2DETAIL ', key2detail)
                        # ACK2RETURN
                        # BUFFER
                        # CODE2ERROR
                        # CODE4SOURCE
                        # COMMANDQUEUE
                        # CONTEXT
                        # COUNT2REFERENCE
                        # COUNT4SOURCE
                        # DATA2CALLBACK
                        # DEVICE
                        # DIRECTORY4SOURCE
                        # EVENT
                        # FUNCTION2CALLBACK
                        # LANGUAGE4SOURCE
                        # NACK2RETURN
                        # PIPE
                        # PLATFORM
                        # QUEUE
                        # SIZE4SOURCE
                        if key2detail == 'COUNT2REFERENCE':
                            print('KEY2RESPONSE ', key2response, 'COUNT2REFERENCE', response4releasekernel[key2response][key2detail])
                            
        # APU COUNT2REFERENCE 0
        # BPU COUNT2REFERENCE 1
        # CPU COUNT2REFERENCE 1
        # DPU COUNT2REFERENCE 1
        # EPU COUNT2REFERENCE 1
        # FPU COUNT2REFERENCE 1
        # GPU COUNT2REFERENCE 0
        # HPU COUNT2REFERENCE 1
        # IPU COUNT2REFERENCE 1
        # JPU COUNT2REFERENCE 1
        # KPU COUNT2REFERENCE 1
        # LPU COUNT2REFERENCE 1
        # MPU COUNT2REFERENCE 1
        # NPU COUNT2REFERENCE 1
        # OPU COUNT2REFERENCE 1
        # PPU COUNT2REFERENCE 1
        # QPU COUNT2REFERENCE 1
        # RPU COUNT2REFERENCE 1
        # SPU COUNT2REFERENCE 1
        # TPU COUNT2REFERENCE 1
        # UPU COUNT2REFERENCE 1
        # VPU COUNT2REFERENCE 1
        # WPU COUNT2REFERENCE 1
        # XPU COUNT2REFERENCE 1
        # YPU COUNT2REFERENCE 1
        # ZPU COUNT2REFERENCE 0
            except:
                print('(Step 290Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4releasekernel ', response4releasekernel)
        
        
        print('FOCUS 16')
        if KB4Focus['retain2kernel4xi'] == 'NACK4XI':                      
            # ---------------------------------------------------------------------------------------------
            # (300) REFERENCE COUNT FOR PROCESSING UNITS RETAINED BY DECREMENTING COUNT WITH 1             
            # ---------------------------------------------------------------------------------------------    
            task4retain2kernel  = {}
            task4retain2kernel ['APU']  = {}
            task4retain2kernel ['APU'] ['COUNT2REFERENCE'] = 1
            task4retain2kernel ['GPU']  = {}
            task4retain2kernel ['GPU'] ['COUNT2REFERENCE'] = 1        
            task4retain2kernel ['WPU']  = {}
            task4retain2kernel ['WPU'] ['COUNT2REFERENCE'] = 1     
            response4retain2kernel = {}    
               
            print('(Step 300A/700) OF KERNEL4XI5TEST - TRYING TO RETAIN KERNEL OF XI DEVICE ', time4xi())    
            # 
            try:                               
                response4retainkernel = retain2kernel4xi(task4retain2kernel)
                print('(Step 300B/700) OF KERNEL4XI5TEST - RETAINED KERNEL OF XI DEVICE ', response4retainkernel)                                                                                             
            except:
                print('(Step 300Z1/700) OF KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL OF XI DEVICE ', time4xi())
            try:                
                     
                keys2response = response4retainkernel.keys()
                for key2response in sorted(keys2response):
                    print('KEY2RESPONSE ', key2response)
                    kb2detail = response4retainkernel[key2response]
                    keys2detail = kb2detail.keys()
                    for key2detail in sorted(keys2detail):
                        print('KEY2DETAIL ', key2detail)
                        # ACK2RETURN
                        # BUFFER
                        # CODE2ERROR
                        # CODE4SOURCE
                        # COMMANDQUEUE
                        # CONTEXT
                        # COUNT2REFERENCE
                        # COUNT4SOURCE
                        # DATA2CALLBACK
                        # DEVICE
                        # DIRECTORY4SOURCE
                        # EVENT
                        # FUNCTION2CALLBACK
                        # LANGUAGE4SOURCE
                        # NACK2RETURN
                        # PIPE
                        # PLATFORM
                        # QUEUE
                        # SIZE4SOURCE
                        if key2detail == 'COUNT2REFERENCE':
                            print('KEY2RESPONSE ', key2response, 'COUNT2REFERENCE', response4retainkernel[key2response][key2detail])

                # APU COUNT2REFERENCE 2
                # BPU COUNT2REFERENCE 1
                # CPU COUNT2REFERENCE 1
                # DPU COUNT2REFERENCE 1
                # EPU COUNT2REFERENCE 1
                # FPU COUNT2REFERENCE 1
                # GPU COUNT2REFERENCE 2
                # HPU COUNT2REFERENCE 1
                # IPU COUNT2REFERENCE 1
                # JPU COUNT2REFERENCE 1
                # KPU COUNT2REFERENCE 1
                # LPU COUNT2REFERENCE 1
                # MPU COUNT2REFERENCE 1
                # NPU COUNT2REFERENCE 1
                # OPU COUNT2REFERENCE 1
                # PPU COUNT2REFERENCE 1
                # QPU COUNT2REFERENCE 1
                # RPU COUNT2REFERENCE 1
                # SPU COUNT2REFERENCE 1
                # TPU COUNT2REFERENCE 1
                # UPU COUNT2REFERENCE 1
                # VPU COUNT2REFERENCE 1
                # WPU COUNT2REFERENCE 2
                # XPU COUNT2REFERENCE 1
                # YPU COUNT2REFERENCE 1
                # ZPU COUNT2REFERENCE 1                                               
            except:
                print('(Step 300Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4retainkernel ', response4retainkernel)
        
        print('FOCUS 17')
        if KB4Focus['set2kernelcallback4xi'] == 'NACK4XI':             
            # ---------------------------------------------------------------------------------------------
            # (310) KERNEL CALLBACK            
            # ---------------------------------------------------------------------------------------------    
            print('(Step 310B/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())     
            try:                               
                task4callback2kernel  = {}
                for key2pu in keys2pu:
                    task4callback2kernel[key2pu]  = {}
                response4setcallback2kernel = set2kernelcallback4xi(task4callback2kernel)
            except:
                print('(Step 310Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())             
            try:    
                key2response = response4setcallback2kernel.keys()
            except:
                print('(Step 310Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())
            try:                
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4setcallback2kernel[key2response] ['CALLBACK'] )
                                            
            except:
                print('(Step 310Z3/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())  
            # APU  :  <function trace2kernel4apu at 0x000000000440B948>
            # BPU  :  <function trace2kernel4bpu at 0x00000000044C9348>
            # CPU  :  <function trace2kernel4cpu at 0x000000000457FCC8>
            # DPU  :  <function trace2kernel4dpu at 0x000000000462B6C8>
            # EPU  :  <function trace2kernel4epu at 0x00000000046B90C8>
            # FPU  :  <function trace2kernel4fpu at 0x0000000004765A48>
            # GPU  :  <function trace2kernel4gpu at 0x00000000047EC448>
            # HPU  :  <function trace2kernel4hpu at 0x00000000048A2DC8>
            # IPU  :  <function trace2kernel4ipu at 0x00000000049517C8>
            # JPU  :  <function trace2kernel4jpu at 0x00000000049DD1C8>
            # KPU  :  <function trace2kernel4kpu at 0x0000000004A97B48>
            # LPU  :  <function trace2kernel4lpu at 0x0000000004B46548>
            # MPU  :  <function trace2kernel4mpu at 0x0000000004BC7EC8>
            # NPU  :  <function trace2kernel4npu at 0x0000000004C738C8>
            # OPU  :  <function trace2kernel4opu at 0x0000000004CF82C8>
            # PPU  :  <function trace2kernel4ppu at 0x0000000004DA9C48>
            # QPU  :  <function trace2kernel4qpu at 0x0000000004E64648>
            # RPU  :  <function trace2kernel4rpu at 0x0000000004F55048>
            # SPU  :  <function trace2kernel4spu at 0x00000000050049C8>
            # TPU  :  <function trace2kernel4tpu at 0x00000000050983C8>
            # UPU  :  <function trace2kernel4upu at 0x0000000005146D48>
            # VPU  :  <function trace2kernel4vpu at 0x000000000520B748>
            # WPU  :  <function trace2kernel4wpu at 0x0000000005353AC8>
            # XPU  :  <function trace2kernel4xpu at 0x00000000052C3148>
            # YPU  :  <function trace2kernel4ypu at 0x00000000028E44C8>
            # ZPU  :  <function trace2kernel4zpu at 0x00000000053DFE48>               
        
        print('FOCUS 11')
        if KB4Focus['get2kernelinfo4xi'] == 'NACK4XI':     
            # ---------------------------------------------------------------------------------------------
            # (320) VERIFY       
            # ---------------------------------------------------------------------------------------------         
            print('(Step 320A/700) OF KERNEL4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
            try:                               
                task4getinfo2kernel = {}
                task4getinfo2kernel ['APU'] = {}
                task4getinfo2kernel ['APU'] ['CALLBACK'] = 'YES'
                task4getinfo2kernel ['GPU'] = {}
                task4getinfo2kernel ['GPU'] ['CALLBACK'] = 'YES'
                task4getinfo2kernel ['XPU'] = {}
                task4getinfo2kernel ['XPU'] ['CALLBACK'] = 'YES'          
                task4getinfo2kernel ['ZPU'] = {}
                task4getinfo2kernel ['ZPU'] ['CALLBACK'] = 'YES'
                    
                response4getinfokernel = get2kernelinfo4xi (task4getinfo2kernel)
                print('(Step 320B/700) OF KERNEL4XI5TEST - VERIFIED XI KNOWLEDGEBASE ', time4xi()) 
                
            except:
                print('(Step 320Z1/700) OF KERNEL4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi()) 
            try:                                                                                                             
                keys2response = response4getinfokernel.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4getinfokernel[key2response] ['CALLBACK'] )
                    # 
            except:
                print('(Step 320Z2700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4getinfokernel ', response4getinfokernel)         
        
        print('FOCUS 18')
        if KB4Focus['trace2kernel4xi'] == 'NACK4XI':                                                                      
            # ---------------------------------------------------------------------------------------------
            # PHASE I: TRACE FUNCTION TESTS                    
            # ---------------------------------------------------------------------------------------------    
            print('(Step 330A/25) OF KERNEL4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
            try:                               
                task4trace2kernel  = {}
                for key2pu in keys2pu:
                    task4trace2kernel[key2pu]  = {}
                    
                response4trace2kernel = trace2kernel4xi(task4trace2kernel) 
                print('(Step 330B/25) OF KERNEL4XI5TEST - TRACED XI: ', time4xi()) 
                 
            except:
                print('(Step 330Z1/25) OF KERNEL4XI5TEST *** FAILED TO TRACE XI: ', time4xi())
            try:                
                key2response = response4trace2kernel.keys()
                for key2response in sorted(keys2response):
                    try:
                        KB4Detail = response4trace2kernel[key2response]
                        keys2detail = KB4Detail.keys()
                        for key2detail in keys2detail:
                            print(key2response, ': ',key2detail, ' ', response4trace2kernel[key2response] [key2detail])
                            #           
                    except:
                        print('(Step 330Z1/25) OF KERNEL4XI5TEST *** FAILED TO PRINT response4trace2kernel: ', response4trace2kernel)        
            # APU :  MESSAGE   {(Step 2Z0/33) failed; trace2kernel4apu-failed {}; time: 06:27:42 11/30/11 Pacific Standard Time}
            # APU :  CLASS   trace2kernel4apu
            # APU :  METHOD   trace2kernel4apu
            # BPU :  MESSAGE   {(Step 2Z0/33) failed; trace2kernel4bpu-failed {}; time: 06:27:42 11/30/11 Pacific Standard Time}
            # BPU :  CLASS   trace2kernel4bpu
            # BPU :  METHOD   trace2kernel4bpu
            # ...                                                               
            except:
                print('(Step 330Z2/25) OF KERNEL4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
        
        print('FOCUS 19')
        if KB4Focus['execute2kernel4xi'] == 'NACK4XI':                  
            # ---------------------------------------------------------------------------------------------
            # PHASE I: BUILD FUNCTION TESTS                    
            # ---------------------------------------------------------------------------------------------    
            print('(Step 340A/25) OF KERNEL4XI5TEST - TRYING TO BUILD FOR XI KERNEL OBJECT: ', time4xi()) 
            try:                               
                task4execute2kernel  = {}
                for key2pu in keys2pu:
                    task4execute2kernel[key2pu]  = {}
                    
                response4execute2kernel = execute2kernel4xi(task4execute2kernel)
                print('(Step 340B/25) OF KERNEL4XI5TEST - BUILT FOR XI KERNEL OBJECT: ', time4xi())  
            except:
                print('(Step 340Z1/25) OF KERNEL4XI5TEST *** FAILED TO BUILD FOR XI KERNEL OBJECT: ', time4xi())
            # {'DPU': {
            #        'ACK2RETURN': ' 1B-11A1-', 
            #        'KERNEL': 
            #             {'CODE2ERROR': 0, 
            #               'LANGUAGE4SOURCE': 'Python', 
            #               'COUNT4SOURCE': 1, 
            #               'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//d//dpu2sampler4xi5test.py': 1337}, 
            #               'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ...
                 
            try:                
                keys2response = response4execute2kernel.keys()                                                       # 'DPU' ...
                for key2response in sorted(keys2response):                                                          # 'DPU' 
                    KB4Detail = response4execute2kernel[key2response]
                    keys2detail = KB4Detail.keys()
                    for key2detail in keys2detail:
                        if key2detail == 'KERNEL':
                            print(key2response, ' ',key2detail, ' ', response4execute2kernel  [key2response] [key2detail])
            # APU   KERNEL   {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2sampler4xi5test.py': 1337}
            # ...
            # ZPU   KERNEL   {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py': 1337}   
            except:
                print('(Step 340Z3/25) OF KERNEL4XI5TEST *** FAILED TO PRINT response4execute2kernel: ', response4execute2kernel)                                                                                                               
        
        
        print('FOCUS 110')
        if KB4Focus['Kernel4Xi'] == 'NACK4XI':                                                                                                                                                
            # ---------------------------------------------------------------------------------------------
            # PHASE II: CLASS TESTS - CREATE OBJECT                         
            # ---------------------------------------------------------------------------------------------
            print('(Step 500A/700) OF KERNEL4XI5TEST - CREATING KERNEL4XI OBJECT ', time4xi())     
            #
            try:
                # ---------------------------------------------------------------------------------------------
                # CREATE OBJECT                        
                # ---------------------------------------------------------------------------------------------        
                p2xi = Kernel4Xi()
                print('(Step 500B/700) OF KERNEL4XI5TEST - CREATED KERNEL4XI OBJECT: ', p2xi)                                  
                # <kernel4xi.Kernel4Xi object at 0x00000000056693C8>
                
            except:
                print('(Step 500Z/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL4XI OBJECT')
            
                   
            print('FOCUS 121A')
            if KB4Focus['get2kernelarginfo'] == 'NACK4XI':   
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - COMPILE SOME KERNEL OBJECT OF XI                      
                # ---------------------------------------------------------------------------------------------    
                print('(Step 520A/700) OF KERNEL4XI5TEST - TRYING TO COMPILE SOME KERNELS OBJECT OF XI ', time4xi())      
                try:
                    task4get2kernelarginfo = {}
                    task4get2kernelarginfo ['BPU'] = 'Yes'
                    task4get2kernelarginfo ['MPU'] = 'Yes'
                    task4get2kernelarginfo ['YPU'] = 'Yes'
                    
                    response4get2kernelarginfo = p2xi.get2kernelarginfo(task4get2kernelarginfo)
                    print('(Step 520B/700) OF KERNEL4XI5TEST - COMPILED SOME KERNEL OBJECTS OF XI ', time4xi())   
                    # OK                                                                 
                except:
                    print('(Step 520Z1/700) OF KERNEL4XI5TEST *** FAILED TO COMPILE SOME KERNEL OBJECT OF XI ', time4xi()) 
                try:                
                    print('(Step 520B/700) OF KERNEL4XI5TEST - COMPILED SOME KERNEL OBJECT OF XI ', time4xi())
                    keys2response = response4get2kernelarginfo.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4get2kernelarginfo[key2response])
                        # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'CALLBACK': <function trace2kernel4apu at 0x00000000051B4948>
                except:
                    print('(Step 520Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelarginfo ', response4get2kernelarginfo) 
            
                               

            
             
            print('FOCUS 122')
            if KB4Focus['add2kernel'] == 'NACK4XI':                      
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ADD INTO KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------                      
                print('(Step 560A/700) OF KERNEL4XI5TEST - TRYING TO ADD INTO KERNEL OBJECT ', time4xi())          
                try:
                    task4add2kernel = {}
        
                    task4add2kernel ['GPU'] = {}
                    task4add2kernel ['GPU'] ['CODE4SOURCE'] = {}            
                    task4add2kernel ['GPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//g//gpu2dummy4xi5test.py'] = {}
                    task4add2kernel ['GPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//g//gpu2dummy4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2kernel ['GPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//g//gpu2dummy4xi5test.py'] [2] = '#<kernel4xi kernel = "gpu2dummy4xi5test.py" />\n'
                    
                    task4add2kernel ['PPU'] = {}
                    task4add2kernel ['PPU'] ['CODE4SOURCE'] = {}            
                    task4add2kernel ['PPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//p//ppu2dummy4xi5test.py'] = {}
                    task4add2kernel ['PPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//p//ppu2dummy4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2kernel ['PPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//p//ppu2dummy4xi5test.py'] [2] = '#<kernel4xi kernel = "ppu2dummy4xi5test.py" />\n'
                    
                    task4add2kernel ['ZPU'] = {}
                    task4add2kernel ['ZPU'] ['CODE4SOURCE'] = {}            
                    task4add2kernel ['ZPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//z//zpu2dummy4xi5test.py'] = {}
                    task4add2kernel ['ZPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//z//zpu2dummy4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2kernel ['ZPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//z//zpu2dummy4xi5test.py'] [2] = '#<kernel4xi kernel = "zpu2dummy4xi5test.py" />\n'
                                                    
                    response4add2kernel = p2xi.add2kernel(task4add2kernel)
                    print('(Step 560B/700) OF KERNEL4XI5TEST - ADDED INTO KERNEL OBJECT ', time4xi()) 
                      
                except:
                    print('(Step 560Z1/700) OF KERNEL4XI5TEST *** FAILED TO ADD INTO KERNEL OBJECT ', time4xi())
                try:                                                                                      
                    keys2response = response4add2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4add2kernel[key2response]) 
                        # GPU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 2, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//g//gpu2sampler4xi5test.py': 1337} ...
                        # PPU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 2, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//p//ppu2sampler4xi5test.py': 1337}
                        # ZPU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 2, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//z//zpu2sampler4xi5test.py': 1337}
                except:
                    print('(Step 560Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel ', response4add2kernel)
                    
            print('FOCUS 124')
            if KB4Focus['delete2kernel'] == 'NACK4XI':        
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - DELETE INSIDE KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------    
                print('(Step 600A/700) OF KERNEL4XI5TEST - TRYING TO DELETE INSIDE KERNEL OBJECT ', time4xi())          
                try:
                    task4delete2kernel = {}
        
                    task4delete2kernel ['GPU'] = {}
                    task4delete2kernel ['GPU'] ['CODE4SOURCE'] = {}            
                    task4delete2kernel ['GPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//g//gpu2dummy4xi5test.py'] = 'Yes'
        
                    task4delete2kernel ['PPU'] = {}
                    task4delete2kernel ['PPU'] ['CODE4SOURCE'] = {}            
                    task4delete2kernel ['PPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//p//ppu2dummy4xi5test.py'] = 'Yes'
                 
                    task4delete2kernel ['ZPU'] = {}
                    task4delete2kernel ['ZPU'] ['CODE4SOURCE'] = {}            
                    task4delete2kernel ['ZPU'] ['CODE4SOURCE'] ['e://scope4xi//041721//zap//lib//z//zpu2dummy4xi5test.py'] = 'Yes'
                                              
                    response4delete2kernel = p2xi.delete2kernel(task4delete2kernel)
                    print('(Step 600B/700) OF KERNEL4XI5TEST - DELETED INSIDE KERNEL OBJECT ', time4xi())  
                    
                except:
                    print('(Step 600Z1/700) OF KERNEL4XI5TEST *** FAILED TO DELETE INSIDE KERNEL OBJECT ', time4xi()) 
                try:                                                                                      
                    keys2response = response4delete2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4delete2kernel[key2response]) 
                        # GPU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 2, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//g//gpu2sampler4xi5test.py': 1337}

                except:
                    print('(Step 600Z2/700) OF KERNEL4XI5TEST *** FAILED TO response4delete2kernel ', response4delete2kernel) 
            
            print('FOCUS 140')
            if KB4Focus['get2kernelinfo'] == 'NACK4XI':         
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - GET SOME KERNEL INFO ABOUT KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------    
                print('(Step 620A/700) OF KERNEL4XI5TEST - TRYING TO GET SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())          
                try:
                    task4get2kernelinfo = {}
        
                    task4get2kernelinfo ['GPU'] = {}
                    task4get2kernelinfo ['GPU'] ['COUNT4SOURCE'] = 'Yes'           
                    task4get2kernelinfo ['GPU'] ['CODE4SOURCE'] = 'Yes'    
                    task4get2kernelinfo ['GPU'] ['SIZE4SOURCE'] = 'Yes'  
                    
                    task4get2kernelinfo ['PPU'] = {}
                    task4get2kernelinfo ['PPU'] ['COUNT4SOURCE'] = 'Yes'        
                    task4get2kernelinfo ['PPU'] ['CODE4SOURCE'] = 'Yes'
                    task4get2kernelinfo ['PPU'] ['SIZE4SOURCE'] = 'Yes'  
                                           
                    task4get2kernelinfo ['ZPU'] = {}
                    task4get2kernelinfo ['ZPU'] ['COUNT4SOURCE'] = 'Yes'    
                    task4get2kernelinfo ['ZPU'] ['CODE4SOURCE'] = 'Yes'  
                    task4get2kernelinfo ['ZPU'] ['SIZE4SOURCE'] = 'Yes'              
                                              
                    response4get2kernelinfo = p2xi.get2kernelinfo(task4get2kernelinfo)
                    print('(Step 620B/700) OF KERNEL4XI5TEST - GOT SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())   
                    
                except:
                    print('(Step 620Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL INFO ABOUT KERNEL OBJECT ', time4xi())
                try:                                                                                      
                    keys2response = response4get2kernelinfo.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4get2kernelinfo[key2response]) 
                        # GPU  :  {'COUNT4SOURCE': 2, 'CODE4SOURCE': {'e://scope4xi//041721//zap//lib//g//gpu2sampler4xi5test.py': {1: '#<profile4xi profile = "11" />\n', 2: ...
                except:
                    print('(Step 620Z2/700) OF KERNEL4XI5TEST *** FAILED TO response4get2kernelinfo ', response4get2kernelinfo)
            
            print('FOCUS 130')
            if KB4Focus['create2kernelsinprogram'] == 'NACK4XI':      
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - CREATE KERNEL OBJECT WITH BINARY FOR XI                      
                # ---------------------------------------------------------------------------------------------    
                print('(Step 640A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNEL OBJECT WITH BINARY FOR XI ', time4xi())      
                try:
                    response4create2kernel = p2xi.create2kernelsinprogram()
                    print('(Step 640B/700) OF KERNEL4XI5TEST - CREATED KERNEL OBJECT WITH BINARY FOR XI ', time4xi()) 
                                                                                     
                except:
                    print('(Step 640Z1/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT WITH BINARY FOR XI ', time4xi())
                try:                
                    print('(Step 640B/700) OF KERNEL4XI5TEST - CREATED KERNEL OBJECT WITH BINARY FOR XI ', time4xi())
                    keys2response = response4create2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4create2kernel[key2response])
                        # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//a//__pycache__//' ...
                        
                except:
                    print('(Step 640Z2/700) OF KERNEL4XI5TEST *** FAILED TO response4create2kernel ', response4create2kernel) 
                 
            print('FOCUS 132')
            if KB4Focus['add2kernel'] == 'NACK4XI':            
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ADD BINARY INTO KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------                      
                print('(Step 680A/700) OF KERNEL4XI5TEST - TRYING TO ADD BINARY INTO KERNEL OBJECT ', time4xi())          
                try:
                    task4add2pwb = {}
        
                    task4add2pwb ['GPU'] = {}
                    task4add2pwb ['GPU'] ['CODE4BINARY'] = {}            
                    task4add2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] = {}
                    task4add2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4add2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'
                    
                    task4add2pwb ['PPU'] = {}
                    task4add2pwb ['PPU'] ['CODE4BINARY'] = {}            
                    task4add2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] = {}
                    task4add2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4add2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'            
                    
                    task4add2pwb ['ZPU'] = {}
                    task4add2pwb ['ZPU'] ['CODE4BINARY'] = {}            
                    task4add2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] = {}
                    task4add2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4add2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'
                                            
                    response4add2pwb = p2xi.add2kernel(task4add2pwb)
                    print('(Step 680B/700) OF KERNEL4XI5TEST - ADDEd BINARY INTO KERNEL OBJECT ', time4xi()) 
                                                                                          
                except:
                    print('(Step 680Z2/700) OF KERNEL4XI5TEST *** FAILED TO ADD BINARY INTO KERNEL OBJECT ', time4xi())    
                try:
                    keys2response = response4add2pwb.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4add2pwb[key2response]) 
                        # GPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//g//__pycache__//', 'LANGUAGE4BINARY': 'Python' ..
                        # PPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//p//__pycache__//', 'LANGUAGE4BINARY': 'Python' 
                        # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//z//__pycache__//', 'LANGUAGE4BINARY': 'Python'
                except:
                    print('(Step 680Z3/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4add2pwb ', response4add2pwb)
                
            print('FOCUS 134')
            if KB4Focus['delete2kernel'] == 'NACK4XI':      
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - DELETE BINARY INTO KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------                      
                print('(Step 700A/700) OF KERNEL4XI5TEST - TRYING TO DELETE BINARY INTO KERNEL OBJECT ', time4xi())          
                try:
                    task4delete2pwb = {}
        
                    task4delete2pwb ['GPU'] = {}
                    task4delete2pwb ['GPU'] ['CODE4BINARY'] = {}            
                    task4delete2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] = {}
                    task4delete2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4delete2pwb ['GPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//g//__pycache__//gpu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'
                    
                    task4delete2pwb ['PPU'] = {}
                    task4delete2pwb ['PPU'] ['CODE4BINARY'] = {}            
                    task4delete2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] = {}
                    task4delete2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4delete2pwb ['PPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//p//__pycache__//ppu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'            
                    
                    task4delete2pwb ['ZPU'] = {}
                    task4delete2pwb ['ZPU'] ['CODE4BINARY'] = {}            
                    task4delete2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] = {}
                    task4delete2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] [1] = b'l\x0c\r\n'
                    task4delete2pwb ['ZPU'] ['CODE4BINARY'] ['e://scope4xi//041721//zap//lib//z//__pycache__//zpu2dummy4xi.cpython-33.pyc'] [2] = b'l\x0c\z\n'
                                              
                    response4delete2pwb = p2xi.delete2kernel(task4delete2pwb)
                    print('(Step 700B/700) OF KERNEL4XI5TEST - DELETED BINARY INTO KERNEL OBJECT ', time4xi())
                    
                except:
                    print('(Step 700Z2/700) OF KERNEL4XI5TEST *** FAILED TO DELETE BINARY INTO KERNEL OBJECT ', time4xi())                                                                                  
                try:    
                    keys2response = response4delete2pwb.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4delete2pwb[key2response]) 
                        # GPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//g//__pycache__//', 'LANGUAGE4BINARY': 'Python'
                except:
                    print('(Step 700Z3/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4delete2pwb ', response4delete2pwb)
                
            print('FOCUS 140')
            if KB4Focus['get2kernelinfo'] == 'NACK4XI':              
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT              
                # ---------------------------------------------------------------------------------------------    
                print('(Step 720A/700) OF KERNEL4XI5TEST - TRYING TO GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())          
                try:
                    task4get2kernelinfo = {}
        
                    task4get2kernelinfo ['GPU'] = {}
                    task4get2kernelinfo ['GPU'] ['COUNT4BINARY'] = 'Yes'           
                    task4get2kernelinfo ['GPU'] ['CODE4BINARY'] = 'Yes'    
                    task4get2kernelinfo ['GPU'] ['SIZE4BINARY'] = 'Yes'  
                    
                    task4get2kernelinfo ['PPU'] = {}
                    task4get2kernelinfo ['PPU'] ['COUNT4BINARY'] = 'Yes'        
                    task4get2kernelinfo ['PPU'] ['CODE4BINARY'] = 'Yes'
                    task4get2kernelinfo ['PPU'] ['SIZE4BINARY'] = 'Yes'  
                                           
                    task4get2kernelinfo ['ZPU'] = {}
                    task4get2kernelinfo ['ZPU'] ['COUNT4BINARY'] = 'Yes'    
                    task4get2kernelinfo ['ZPU'] ['CODE4BINARY'] = 'Yes'  
                    task4get2kernelinfo ['ZPU'] ['SIZE4BINARY'] = 'Yes'              
                                              
                    response4get2kernelinfo = p2xi.get2kernelinfo(task4get2kernelinfo)
                    print('(Step 720B/700) OF KERNEL4XI5TEST - GOT SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())   
                     
                except:
                    print('(Step 720Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL BINARY INFO ABOUT KERNEL OBJECT ', time4xi())
                try:                                                                                     
                    keys2response = response4get2kernelinfo.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4get2kernelinfo[key2response]) 
                        # GPU  :  {'CODE4BINARY': {'e://scope4xi//041721//zap//lib//g//__pycache__//gpu2image4xi.cpython-33.pyc': {1: b'l\x0c\r\n', 2: b'\xf8U\x ...
                        
                except:
                    print('(Step 720Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4get2kernelinfo', tresponse4get2kernelinfo)
            
            print('FOCUS 150')
            if KB4Focus['set2kernel'] == 'NACK4XI':                       
                # ---------------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET KERNEL WITH CLASS TO ALL PROCESSING UNITS - ALL ATTRIBUTES                         
                # ---------------------------------------------------------------------------------------------------    
                #   
                print('(Step 760A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL WITH CLASS TO ALL PROCESSING UNITS ', time4xi())    
            
                KB2setkernel = {}
                KB2setkernel ['APU'] = {}
                KB2setkernel ['BPU'] = {}
                KB2setkernel ['CPU'] = {}
                KB2setkernel ['DPU'] = {}
                KB2setkernel ['EPU'] = {}
                KB2setkernel ['FPU'] = {}
                KB2setkernel ['GPU'] = {}
                KB2setkernel ['HPU'] = {}
                KB2setkernel ['IPU'] = {}
                KB2setkernel ['JPU'] = {}
                KB2setkernel ['KPU'] = {}
                KB2setkernel ['LPU'] = {}
                KB2setkernel ['MPU'] = {}
                KB2setkernel ['NPU'] = {}
                KB2setkernel ['OPU'] = {}
                KB2setkernel ['PPU'] = {}
                KB2setkernel ['QPU'] = {}
                KB2setkernel ['RPU'] = {}
                KB2setkernel ['SPU'] = {}
                KB2setkernel ['TPU'] = {}
                KB2setkernel ['UPU'] = {}
                KB2setkernel ['VPU'] = {}
                KB2setkernel ['WPU'] = {}
                KB2setkernel ['XPU'] = {}
                KB2setkernel ['YPU'] = {}
                KB2setkernel ['ZPU'] = {}
                keys2setkernel = KB2setkernel.keys()
                
                task4set2kernel = {} 
            
                # ---------------------------------------------------------------------------------------------
                # (760A) GET PLATFORM IDs
                # ---------------------------------------------------------------------------------------------    
                print('(Step 760A1/700) OF KERNEL4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
                try:
                    platform2xi = get2platformids4xi()
                    print('(Step 760A2/33) OF KERNEL4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                    # 
                     
                except:
                    print('(Step 760AZ/33) OF KERNEL4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
            
                # ---------------------------------------------------------------------------------------------
                # (760B) INITIALIZE XI DEVICE                       
                # ---------------------------------------------------------------------------------------------    
                print('(Step 760B1/33) OF KERNEL4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
                try:
                    device2xi = init2device4xi()                                                                                
                    keys2device = device2xi.keys()
                    for key2device in sorted(keys2device):
                        print(key2device, device2xi[key2device])
                        # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
                        # ...
                        # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
                except:
                    print('(Step 760BZ/33) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())  
                        
                    
                # ---------------------------------------------------------------------------------------------
                # (760C) CREATE XI CONTEXT                  
                # ---------------------------------------------------------------------------------------------    
                print('(Step 760C1/700) OF KERNEL4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
                try:
                    context2xi = create2context4xi()                                                                            
                    keys2context = context2xi.keys()
                    for key2context in sorted(keys2context):
                        print(key2context, device2xi[key2context])
                        # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000008409568', 'PROFILING2QUEUE': 'ACK' ...
                        # ...
                        # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000008409568', 'PROFILING2QUEUE': 'ACK' ...   
                except:
                    print('(Step 760CZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
                    
                        
                # ---------------------------------------------------------------------------------------------
                # (760D) CREATE XI COMMANDQUEUE                
                # ---------------------------------------------------------------------------------------------    
                print('(Step 760D1/700) OF KERNEL4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
                try:
                    queue4command = create2commandqueue4xi()                                                                            
                    keys2commandqueue = queue4command.keys()
                    for key2commandqueue in sorted(keys2commandqueue):
                        print(key2commandqueue, queue4command[key2commandqueue])
                        # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                        # ...
                        # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                          
                except:
                    print('(Step 760DZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())         
                
                # -------------------------------------------------------------------------------------------------    
                # (780) INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 780A/700) OF KERNEL4XI5TEST - TRYING TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):
                        task4set2kernel [key2setkernel] = {}
                        print(key2setkernel, task4set2kernel [key2setkernel])
                        # 
                        
                except:
                    print('(Step 780Z/700) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                                
                # -------------------------------------------------------------------------------------------------    
                # (780) SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 780A/700) OF KERNEL4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):
                        task4set2kernel [key2setkernel] ['CONTEXT'] = context2xi [key2setkernel] 
                        print(key2setkernel, ' CONTEXT: ', task4set2kernel [key2setkernel] ['CONTEXT'])
                        # 
                             
                except:
                    print('(Step 780Z/700) OF KERNEL4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi()) 
                    
                # -------------------------------------------------------------------------------------------------    
                # (800) SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 800A/700) OF KERNEL4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['DEVICE'] = device2xi [key2setkernel] 
                        print(key2setkernel, 'DEVICE:' , task4set2kernel [key2setkernel] ['DEVICE'])
                        # 
                         
                except:
                    print('(Step 800Z/700) OF KERNEL4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            
                    
                # -------------------------------------------------------------------------------------------------    
                # (820) SET ERROR CODE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 820A/700) OF KERNEL4XI5TEST - TRYING TO SET PROPERTIES FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['CODE2ERROR'] = 0  
                        print(key2setkernel, ' CODE2ERROR: ', task4set2kernel [key2setkernel] ['CODE2ERROR'])
                        # 
                         
                except:
                    print('(Step 820Z/700) OF KERNEL4XI5TEST *** FAILED TO SET PROPERTIES OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            
                    
                # -------------------------------------------------------------------------------------------------    
                # (840) SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 840A/700) OF KERNEL4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['QUEUE'] = Queue4Xi()
                        print(key2setkernel, ' QUEUE: ', task4set2kernel [key2setkernel] ['QUEUE'])
                        # 
                         
                except:
                    print('(Step 840Z/700) OF KERNEL4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                            
                    
                # -------------------------------------------------------------------------------------------------    
                # (860) SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 860A/700) OF KERNEL4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel  [key2setkernel] ['PIPE'] = Pipe4Xi() 
                        print(key2setkernel, ' PIPE: ', task4set2kernel  [key2setkernel] ['PIPE']) 
                        # 
                        
                except:
                    print('(Step 860Z/700) OF KERNEL4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                    
                    
                # -------------------------------------------------------------------------------------------------    
                # (870) SET COMMAND QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 870A/700) OF KERNEL4XI5TEST - TRYING TO SET COMMAND QUEUE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):              
                        task4set2kernel  [key2setkernel] ['COMMANDQUEUE'] = queue4command [key2setkernel]
                        print(key2setkernel, ' COMMANDQUEUE: ', task4set2kernel  [key2setkernel] ['COMMANDQUEUE']) 
                        #  
                         
                except:
                    print('(Step 860Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                    
                                                                        
                    
                # ---------------------------------------------------------------------------------------------
                # (880) FINALLY SET KERNEL AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
                # ---------------------------------------------------------------------------------------------          
                response4setkernel = {} 
                print('(Step 880A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL4XI WITH ', time4xi())   
                try:                               
                    response4setkernel = p2xi.set2kernel(task4set2kernel)
                    print('(Step 880B/700) OF KERNEL4XI5TEST - SET KERNEL4XI  WITH ', response4setkernel)
                                                                                                                              
                except:
                    print('(Step 880Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL4XI  WITH *** ', time4xi()) 
                try:                                                                                              
        
                    keys2response = response4setkernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4setkernel[key2response])
                        # APU  :  {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1, 'SIZE4SOURCE': {'e://scope4xi//041721//zap//lib//a//apu2sampler4xi5test.py': 1337}
                        # ...
                        # ZPU  : ... 
                except:
                    print('(Step 880Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4setkernel ', response4setkernel)  
                    
            print('FOCUS 160')
            if KB4Focus['set2kernelarg'] == 'NACK4XI':                      
                # ---------------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET KERNEL BINARY WITH CLASS TO ALL PROCESSING UNITS - ALL ATTRIBUTES                         
                # ---------------------------------------------------------------------------------------------------    
                #   
                print('(Step 890A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL BINARY WITH CLASS TO ALL PROCESSING UNITS ', time4xi())    
            
                KB2setkernel = {}
                KB2setkernel ['APU'] = {}
                KB2setkernel ['BPU'] = {}
                KB2setkernel ['CPU'] = {}
                KB2setkernel ['DPU'] = {}
                KB2setkernel ['EPU'] = {}
                KB2setkernel ['FPU'] = {}
                KB2setkernel ['GPU'] = {}
                KB2setkernel ['HPU'] = {}
                KB2setkernel ['IPU'] = {}
                KB2setkernel ['JPU'] = {}
                KB2setkernel ['KPU'] = {}
                KB2setkernel ['LPU'] = {}
                KB2setkernel ['MPU'] = {}
                KB2setkernel ['NPU'] = {}
                KB2setkernel ['OPU'] = {}
                KB2setkernel ['PPU'] = {}
                KB2setkernel ['QPU'] = {}
                KB2setkernel ['RPU'] = {}
                KB2setkernel ['SPU'] = {}
                KB2setkernel ['TPU'] = {}
                KB2setkernel ['UPU'] = {}
                KB2setkernel ['VPU'] = {}
                KB2setkernel ['WPU'] = {}
                KB2setkernel ['XPU'] = {}
                KB2setkernel ['YPU'] = {}
                KB2setkernel ['ZPU'] = {}
                keys2setkernel = KB2setkernel.keys()
                
                task4set2kernel = {} 
            
                # ---------------------------------------------------------------------------------------------
                # (890A) GET PLATFORM IDs
                # ---------------------------------------------------------------------------------------------    
                print('(Step 890A1/700) OF KERNEL4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
                try:
                    platform2xi = get2platformids4xi()
                    print('(Step 890A2/33) OF KERNEL4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                    # 
                     
                except:
                    print('(Step 890AZ/33) OF KERNEL4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
            
                # ---------------------------------------------------------------------------------------------
                # (890B) INITIALIZE XI DEVICE                       
                # ---------------------------------------------------------------------------------------------    
                print('(Step 890B1/33) OF KERNEL4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
                try:
                    device2xi = init2device4xi()                                                                                
                    keys2device = device2xi.keys()
                    for key2device in sorted(keys2device):
                        print(key2device, device2xi[key2device])
                        # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
                        # ...
                        # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
                except:
                    print('(Step 890BZ/33) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())  
                        
                    
                # ---------------------------------------------------------------------------------------------
                # (890C) CREATE XI CONTEXT                  
                # ---------------------------------------------------------------------------------------------    
                print('(Step 890C1/700) OF KERNEL4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
                try:
                    context2xi = create2context4xi()                                                                            
                    keys2context = context2xi.keys()
                    for key2context in sorted(keys2context):
                        print(key2context, device2xi[key2context])
                        # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000008409568', 'PROFILING2QUEUE': 'ACK' ...
                        # ...
                        # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000008409568', 'PROFILING2QUEUE': 'ACK' ...   
                except:
                    print('(Step 890CZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
                    
                        
                # ---------------------------------------------------------------------------------------------
                # (890D) CREATE XI COMMANDQUEUE                
                # ---------------------------------------------------------------------------------------------    
                print('(Step 890D1/700) OF KERNEL4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
                try:
                    queue4command = create2commandqueue4xi()                                                                            
                    keys2commandqueue = queue4command.keys()
                    for key2commandqueue in sorted(keys2commandqueue):
                        print(key2commandqueue, queue4command[key2commandqueue])
                        # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                        # ...
                        # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
                          
                except:
                    print('(Step 890DZ/700) OF KERNEL4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())         
                
                # -------------------------------------------------------------------------------------------------    
                # (890E) INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890E/700) OF KERNEL4XI5TEST - TRYING TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):
                        task4set2kernel [key2setkernel] = {}
                        print(key2setkernel, task4set2kernel [key2setkernel])
                        # 
                        
                except:
                    print('(Step 890EZ/700) OF KERNEL4XI5TEST *** FAILED TO INITIALIZE TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                                
                # -------------------------------------------------------------------------------------------------    
                # (890F) SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890FA/700) OF KERNEL4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):
                        task4set2kernel [key2setkernel] ['CONTEXT'] = context2xi [key2setkernel] 
                        print(key2setkernel, ' CONTEXT: ', task4set2kernel [key2setkernel] ['CONTEXT'])
                        # 
                             
                except:
                    print('(Step 890FZ/700) OF KERNEL4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi()) 
                    
                # -------------------------------------------------------------------------------------------------    
                # (890G) SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890GA/700) OF KERNEL4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['DEVICE'] = device2xi [key2setkernel] 
                        print(key2setkernel, 'DEVICE:' , task4set2kernel [key2setkernel] ['DEVICE'])
                        # 
                         
                except:
                    print('(Step 890GZ/700) OF KERNEL4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            
                    
                # -------------------------------------------------------------------------------------------------    
                # (890H) SET ERROR CODE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890HA/700) OF KERNEL4XI5TEST - TRYING TO SET PROPERTIES FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['CODE2ERROR'] = 0  
                        print(key2setkernel, ' CODE2ERROR: ', task4set2kernel [key2setkernel] ['CODE2ERROR'])
                        # 
                         
                except:
                    print('(Step 890HZ/700) OF KERNEL4XI5TEST *** FAILED TO SET PROPERTIES OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
            
                    
                # -------------------------------------------------------------------------------------------------    
                # (890I) SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890IA/700) OF KERNEL4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel [key2setkernel] ['QUEUE'] = Queue4Xi()
                        print(key2setkernel, ' QUEUE: ', task4set2kernel [key2setkernel] ['QUEUE'])
                        # 
                         
                except:
                    print('(Step 890IZ/700) OF KERNEL4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                            
                    
                # -------------------------------------------------------------------------------------------------    
                # (890J) SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890JA/700) OF KERNEL4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):        
                        task4set2kernel  [key2setkernel] ['PIPE'] = Pipe4Xi() 
                        print(key2setkernel, ' PIPE: ', task4set2kernel  [key2setkernel] ['PIPE']) 
                        # 
                        
                except:
                    print('(Step 890JZ/700) OF KERNEL4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                    
                    
                # -------------------------------------------------------------------------------------------------    
                # (890K) SET COMMAND QUEUE OF TASK4SET2KERNEL FOR PROCESSING UNITS              
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890KA/700) OF KERNEL4XI5TEST - TRYING TO SET COMMAND QUEUE FOR PROCESSING UNITS ', time4xi())
                try:
                    for key2setkernel in sorted(keys2setkernel):              
                        task4set2kernel  [key2setkernel] ['COMMANDQUEUE'] = queue4command [key2setkernel]
                        print(key2setkernel, ' COMMANDQUEUE: ', task4set2kernel  [key2setkernel] ['COMMANDQUEUE']) 
                        #  
                         
                except:
                    print('(Step 890KZ2/700) OF KERNEL4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2KERNEL FOR PROCESSING UNITS ', time4xi())
                    
                
                # -------------------------------------------------------------------------------------------------    
                # (890L) SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY            
                # -------------------------------------------------------------------------------------------------          
                print('(Step 890LA/700) OF KERNEL4XI5TEST - TRYING TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())
                alpha2set = {}
                alpha2set['a'] = 'APU'
                alpha2set['b'] = 'BPU'
                alpha2set['c'] = 'CPU'
                alpha2set['d'] = 'DPU'
                alpha2set['e'] = 'EPU'
                alpha2set['f'] = 'FPU'
                alpha2set['g'] = 'GPU'
                alpha2set['h'] = 'HPU'
                alpha2set['i'] = 'IPU'
                alpha2set['j'] = 'JPU'
                alpha2set['k'] = 'KPU'
                alpha2set['l'] = 'LPU'
                alpha2set['m'] = 'MPU'
                alpha2set['n'] = 'NPU'
                alpha2set['o'] = 'OPU'
                alpha2set['p'] = 'PPU'
                alpha2set['q'] = 'QPU'
                alpha2set['r'] = 'RPU'
                alpha2set['s'] = 'SPU'
                alpha2set['t'] = 'TPU'
                alpha2set['u'] = 'UPU'
                alpha2set['v'] = 'VPU'
                alpha2set['w'] = 'WPU'
                alpha2set['x'] = 'XPU'
                alpha2set['y'] = 'YPU'
                alpha2set['z'] = 'ZPU'
                print('(Step 890LB/700) OF KERNEL4XI5TEST - alpha2set ', alpha2set)
                # {'a': 'APU', 'c': 'CPU', 'b': 'BPU', 'e': 'EPU', 'd': 'DPU', 'g': 'GPU' ....
                try:
                    keys2alpha      = alpha2set.keys()
                    print('(Step 890LC/700) OF KERNEL4XI5TEST - keys2alpha ', keys2alpha)
                    # dict_keys(['a', 'c', 'b', 'e', 'd', 'g', 'f', 'i', 'h', 'k', 'j', 'm', 'l', 'o', 'n', 'q', 'p', 's', 'r', 'u', 't', 'w', 'v', 'y', 'x', 'z'])
                    language2binary = 'Python'
                    print('(Step 890LD/700) OF KERNEL4XI5TEST - language2binary ', language2binary)
                    # Python
                    size2binary     = 1
                    print('(Step 890LE/700) OF KERNEL4XI5TEST - size2binary ', size2binary)
                    # 1
                    lib2set         = 'e://scope4xi//041721//zap//lib//'
                    print('(Step 890LF/700) OF KERNEL4XI5TEST - lib2set ', lib2set)
                    # e://scope4xi//041721//zap//lib//
                    cache2set       = '//__pycache__//'
                    print('(Step 890LG/700) OF KERNEL4XI5TEST - cache2set ', cache2set)
                    # //__pycache__//
                    kb2set = {}
                except:
                    print('(Step 890LZ1/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())
                try:                    
                    for key2alpha in sorted(keys2alpha):                                                                # a,b,c ....
                        key2pu = alpha2set[key2alpha]                                                                   # APU, BPU, CPU ...
                        print('(Step 890LH/700) OF KERNEL4XI5TEST - key2pu ', key2pu)
                        # APU
                        
                        kb2set[key2pu]                       = {}
                        directory2binary                     = lib2set + key2alpha + cache2set
                        print('(Step 890LI/700) OF KERNEL4XI5TEST - directory2binary ', directory2binary)
                        # e://scope4xi//041721//zap//lib//a//__pycache__//
                        
                        kb2set [key2pu] ['LANGUAGE4BINARY']  = language2binary
                        
                        kb2set [key2pu] ['DIRECTORY4BINARY'] = directory2binary
                        
                        key2binary = lib2set + key2alpha + cache2set + key2alpha + 'pu2sampler4xi.cpython-33.pyc'
                        print('(Step 890LI/700) OF KERNEL4XI5TEST - key2binary ', key2binary)
                        # e://scope4xi//041721//zap//lib//a//__pycache__//apu2sampler4xi.cpython-33.pyc
                        
                        kb2set [key2pu] ['CODE4BINARY']     = {}
                        kb2set [key2pu] ['CODE4BINARY'] [1] = b'l\x0c\r\n'
                        print('(Step 890LK/700) OF KERNEL4XI5TEST - CODE4BINARY ', kb2set [key2pu] ['CODE4BINARY'])
                        # {1: b'l\x0c\r\n'}
                        kb2set [key2pu] ['SIZE4BINARY']     = len(kb2set [key2pu] ['CODE4BINARY']) 
                        print('(Step 890LK/700) OF KERNEL4XI5TEST - SIZE4BINARY ', kb2set [key2pu] ['SIZE4BINARY'])
                        # 1
                        # key2pu  ZPU
                        # directory2binary  e://scope4xi//041721//zap//lib//z//__pycache__//
                        # key2binary  e://scope4xi//041721//zap//lib//z//__pycache__//zpu2sampler4xi.cpython-33.pyc
                        # CODE4BINARY  {1: b'l\x0c\r\n'}
                        # SIZE4BINARY  1                    
                except:
                    print('(Step 890LZ2/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())            
                
                print('(Step 890LL/700) OF KERNEL4XI5TEST - KEYS OF kb2set ', kb2set.keys())  
                # dict_keys(['DPU', 'EPU', 'BPU', 'CPU', 'VPU', 'RPU', 'WPU', 'SPU', 'PPU', 'QPU', 'KPU', 'YPU', 'LPU', 'ZPU', 'HPU', 'FPU', 'TPU', 'GPU', 'UPU', 'XPU', 'OPU', 'APU', 'MPU', 'IPU', 'NPU', 'JPU'])
    
                print('(Step 890LM/700) OF KERNEL4XI5TEST - kb2set ', kb2set) 
                # {'DPU': {'CODE4BINARY': {1: b'l\x0c\r\n'},
                #  'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//d//__pycache__//',
                #  'SIZE4BINARY': 1,
                #  'LANGUAGE4BINARY': 'Python'}, 
                #  'EPU': {'CODE4BINARY': {1: b'l\x0c\r\n'},
                #  'DIRECTORY4BINARY': 'e://scope4xi//041721//zap//lib//e//__pycache__//',
                #  'SIZE4BINARY': 1,
                #  'LANGUAGE4BINARY': 'Python'},
                #  
                # ...
                try:
                    for key2setkernel in sorted(keys2setkernel):
                        
                        print('KEY2SETKERNEL ', key2setkernel) 
                        task4set2kernel  [key2setkernel] ['LANGUAGE4BINARY'] = kb2set [key2setkernel] ['LANGUAGE4BINARY']
                        print(key2setkernel, ' LANGUAGE4BINARY: ', task4set2kernel  [key2setkernel] ['LANGUAGE4BINARY']) 
                        task4set2kernel  [key2setkernel] ['DIRECTORY4BINARY'] = kb2set [key2setkernel] ['DIRECTORY4BINARY']
                        print(key2setkernel, ' DIRECTORY4BINARY: ', task4set2kernel  [key2setkernel] ['DIRECTORY4BINARY']) 
                        task4set2kernel  [key2setkernel] ['CODE4BINARY'] = kb2set [key2setkernel] ['CODE4BINARY']
                        print(key2setkernel, ' CODE4BINARY: ', task4set2kernel  [key2setkernel] ['CODE4BINARY']) 
                        task4set2kernel  [key2setkernel] ['SIZE4BINARY'] = kb2set [key2setkernel] ['SIZE4BINARY']
                        print(key2setkernel, ' SIZE4BINARY: ', task4set2kernel  [key2setkernel] ['SIZE4BINARY']) 
                # KEY2SETKERNEL  APU
                # APU  LANGUAGE4BINARY:  Python
                # APU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//a//__pycache__//
                # APU  CODE4BINARY:  {1: b'l\x0c\r\n'}
                # APU  SIZE4BINARY:  1
                # ...
                # KEY2SETKERNEL  ZPU
                # ZPU  LANGUAGE4BINARY:  Python
                # ZPU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//z//__pycache__//
                # ZPU  CODE4BINARY:  {1: b'l\x0c\r\n'}
                # ZPU  SIZE4BINARY:  1
                #                                         
                except:
                    print('(Step 890LZ3/700) OF KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4BINARY, LANGUAGE4BINARY, SIZE4BINARY, BINARY ', time4xi())                                                                        
                    
                # ---------------------------------------------------------------------------------------------
                # (890M) FINALLY SET KERNEL AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
                # ---------------------------------------------------------------------------------------------          
                response4setkernel = {} 
                print('(Step 890MA/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL4XI WITH BINARY', time4xi())   
                try:                               
                    response4setkernel = p2xi.set2kernelarg(task4set2kernel)
                    print('(Step 890MB/700) OF KERNEL4XI5TEST - SET KERNEL4XI  WITH BINARY ', response4setkernel)
                    #                                                                                                         
                except:
                    print('(Step 890MZ1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL4XI  WITH BINARY*** ', time4xi())  
                try:                                                                                              
                    keys2response = response4setkernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4setkernel[key2response])
                        # KEY2SETKERNEL  APU
                        # APU  LANGUAGE4BINARY:  Python
                        # APU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//a//__pycache__//
                        # APU  CODE4BINARY:  {1: b'l\x0c\r\n'}
                        # APU  SIZE4BINARY:  1
                        # KEY2SETKERNEL  BPU
                        # BPU  LANGUAGE4BINARY:  Python
                        # BPU  DIRECTORY4BINARY:  e://scope4xi//041721//zap//lib//b//__pycache__//
                        # BPU  CODE4BINARY:  {1: b'l\x0c\r\n'}
                        # BPU  SIZE4BINARY:  1
                except:
                    print('(Step 890MZ2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4setkernel ', response4setkernel)  
            
            print('FOCUS 170')
            if KB4Focus['release2kernel'] == 'NACK4XI':              
                # ---------------------------------------------------------------------------------------------
                # (900) REFERENCE COUNT FOR PROCESSING UNITS RELEASED BY DECREMENTING COUNT WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4release2kernel  = {}
                task4release2kernel ['APU']  = {}
                task4release2kernel ['APU'] ['COUNT2REFERENCE'] = 1
                task4release2kernel ['ZPU']  = {}
                task4release2kernel ['ZPU'] ['COUNT2REFERENCE'] = 1     
                response4release2kernel = {}    
                   
                print('(Step 900A/700) OF KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF XI DEVICE ', time4xi())    
                # 
                try:                               
                    response4releasekernel = p2xi.release2kernel(task4release2kernel)
                    print('(Step 900B/700) OF KERNEL4XI5TEST - RELEASED KERNEL OF XI DEVICE ', time4xi()) 
                                                                                                                 
                except:
                    print('(Step 900Z1/700) OF KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF XI DEVICE ', time4xi())
                try:                
                    keys2response = response4releasekernel.keys()
                    for key2response in sorted(keys2response):
                        print('KEY2RESPONSE ', key2response)
                        kb2detail = response4releasekernel[key2response]
                        keys2detail = kb2detail.keys()
                        for key2detail in sorted(keys2detail):
                            print('KEY2DETAIL ', key2detail)
                            # 
                            if key2detail == 'COUNT2REFERENCE':
                                print('KEY2RESPONSE ', key2response, 'COUNT2REFERENCE', response4releasekernel[key2response][key2detail])
                                # APU COUNT2REFERENCE 0 <-- OK
                                # BPU COUNT2REFERENCE 1
                                # CPU COUNT2REFERENCE 1
                                # DPU COUNT2REFERENCE 1
                                # EPU COUNT2REFERENCE 1
                                # FPU COUNT2REFERENCE 1
                                # GPU COUNT2REFERENCE 1
                                # HPU COUNT2REFERENCE 1
                                # IPU COUNT2REFERENCE 1
                                # JPU COUNT2REFERENCE 1
                                # KPU COUNT2REFERENCE 1
                                # LPU COUNT2REFERENCE 1
                                # MPU COUNT2REFERENCE 1
                                # NPU COUNT2REFERENCE 1
                                # OPU COUNT2REFERENCE 1
                                # PPU COUNT2REFERENCE 1
                                # QPU COUNT2REFERENCE 1
                                # RPU COUNT2REFERENCE 1
                                # SPU COUNT2REFERENCE 1
                                # TPU COUNT2REFERENCE 1
                                # UPU COUNT2REFERENCE 1
                                # VPU COUNT2REFERENCE 1
                                # WPU COUNT2REFERENCE 1
                                # XPU COUNT2REFERENCE 1
                                # YPU COUNT2REFERENCE 1
                                # ZPU COUNT2REFERENCE 0 <-- OK                                
                except:
                    print('(Step 900Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4releasekernel ', response4releasekernel)
            
    
            print('FOCUS 180')
            if KB4Focus['retain2kernel'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # (910) REFERENCE COUNT FOR TWO PROCESSING UNITS RETAINED BY INCREMENTING COUNT WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4retain2kernel  = {}
                task4retain2kernel ['APU']  = {}
                task4retain2kernel ['APU'] ['COUNT2REFERENCE'] = 1
                task4retain2kernel ['GPU']  = {}
                task4retain2kernel ['GPU'] ['COUNT2REFERENCE'] = 1    
                task4retain2kernel ['ZPU']  = {}
                task4retain2kernel ['ZPU'] ['COUNT2REFERENCE'] = 1    
                 
                response4retainkernel = {}
                print('(Step 910A/700) OF KERNEL4XI5TEST - TRYING TO RETAIN KERNEL OF XI DEVICE ', time4xi())   
                try:                               
                    response4retainkernel = p2xi.retain2kernel(task4retain2kernel)
                    print('(Step 910B/700) OF KERNEL4XI5TEST - RETAINED KERNEL OF XI DEVICE ', time4xi())                                                                                                
                except:
                    print('(Step 910Z1/700) OF KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL OF XI DEVICE ', time4xi()) 
                try:    
                    keys2response = response4retainkernel.keys()
                    for key2response in sorted(keys2response):
                        print('KEY2RESPONSE ', key2response)
                        kb2detail = response4retainkernel[key2response]
                        keys2detail = kb2detail.keys()
                        for key2detail in sorted(keys2detail):
                            print('KEY2DETAIL ', key2detail)
                            # 
                            if key2detail == 'COUNT2REFERENCE':
                                print('KEY2RESPONSE ', key2response, 'COUNT2REFERENCE', response4retainkernel[key2response][key2detail])
                                # APU COUNT2REFERENCE 2 <-- OK
                                # BPU COUNT2REFERENCE 1
                                # CPU COUNT2REFERENCE 1
                                # DPU COUNT2REFERENCE 1
                                # EPU COUNT2REFERENCE 1
                                # FPU COUNT2REFERENCE 1
                                # GPU COUNT2REFERENCE 2 <-- OK
                                # HPU COUNT2REFERENCE 1
                                # IPU COUNT2REFERENCE 1
                                # JPU COUNT2REFERENCE 1
                                # KPU COUNT2REFERENCE 1
                                # LPU COUNT2REFERENCE 1
                                # MPU COUNT2REFERENCE 1
                                # NPU COUNT2REFERENCE 1
                                # OPU COUNT2REFERENCE 1
                                # PPU COUNT2REFERENCE 1
                                # QPU COUNT2REFERENCE 1
                                # RPU COUNT2REFERENCE 1
                                # SPU COUNT2REFERENCE 1
                                # TPU COUNT2REFERENCE 1
                                # UPU COUNT2REFERENCE 1
                                # VPU COUNT2REFERENCE 1
                                # WPU COUNT2REFERENCE 1
                                # XPU COUNT2REFERENCE 1
                                # YPU COUNT2REFERENCE 1
                                # ZPU COUNT2REFERENCE 2 <-- OK                                     
                except:
                    print('(Step 910Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4retainkernel ', response4retainkernel) 
            
            print('FOCUS 200')
            if KB4Focus['set2kernelcallback'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # (920) KERNEL CALLBACK            
                # ---------------------------------------------------------------------------------------------    
                print('(Step 920A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())     
                try:                               
                    task4callback2kernel  = {}
                    for key2pu in keys2pu:
                        task4callback2kernel[key2pu]  = {}
                    response4setcallback2kernel = p2xi.set2kernelcallback(task4callback2kernel)
                    print('(Step 920B/700) OF KERNEL4XI5TEST - SET KERNEL CALLBACK OF XI DEVICE ', response4setcallback2kernel)   
                    #  
                except:
                    print('(Step 920Z3/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi()) 

 
                  
            print('FOCUS 140')
            if KB4Focus['get2kernelinfo'] == 'NACK4XI':         
                print('(Step 920B/700) OF KERNEL4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
                try:                               
                    task4getinfo2kernel = {}
                    task4getinfo2kernel ['APU'] = {}
                    task4getinfo2kernel ['APU'] ['CALLBACK'] = 'YES'
                    task4getinfo2kernel ['GPU'] = {}
                    task4getinfo2kernel ['GPU'] ['CALLBACK'] = 'YES'
                    task4getinfo2kernel ['XPU'] = {}
                    task4getinfo2kernel ['XPU'] ['CALLBACK'] = 'YES'          
                    task4getinfo2kernel ['ZPU'] = {}
                    task4getinfo2kernel ['ZPU'] ['CALLBACK'] = 'YES'    
                            
                    response4getinfokernel = p2xi.get2kernelinfo (task4getinfo2kernel)
                    print('(Step 920C/700) OF KERNEL4XI5TEST - VERIFIED XI KNOWLEDGEBASE ', response4getinfokernel)
                except:
                    print('(Step 920Z1/700) OF KERNEL4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi())                        
  
            
            print('FOCUS 210')
            if KB4Focus['trace2kernel'] == 'NACK4XI':                                                                    
                # ---------------------------------------------------------------------------------------------
                # PHASE II: TRACE CLASS TESTS                    
                # ---------------------------------------------------------------------------------------------    
                print('(Step 930A/25) OF KERNEL4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
                try:                               
                    task4trace2kernel  = {}
                    for key2pu in keys2pu:
                        task4trace2kernel[key2pu]  = {}
                        
                    response4trace2kernel = p2xi.trace2kernel(task4trace2kernel)
                    print('(Step 930A/25) OF KERNEL4XI5TEST - TRACED XI: ', response4trace2kernel)
                    # {'DPU': {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dpu-failed {}; time: 09:27:55 11/30/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4dpu', 'METHOD': 'trace2kernel4dpu'}, 'EPU':   
                except:
                    print('(Step 930Z1/25) OF KERNEL4XI5TEST *** FAILED TO TRACE XI: ', time4xi())

                
            print('FOCUS 240')
            if KB4Focus['execute2kernel'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE II: BUILD CLASS TESTS                    
                # ---------------------------------------------------------------------------------------------    
                print('(Step 940A/25) OF KERNEL4XI5TEST - TRYING TO BUILD XI: ', time4xi()) 
                try:                               
                    task4execute2kernel  = {}
                    for key2pu in keys2pu:
                        task4execute2kernel[key2pu]  = {}
                        
                    response4execute2kernel = p2xi.execute2kernel(task4execute2kernel)
                    print('(Step 940B/25) OF KERNEL4XI5TEST - BUILT XI: ', response4execute2kernel)
                    # {'DPU': {'ACK2RETURN': ' 1B-11A1-', 'KERNEL': {'CODE2ERROR': 0, 'LANGUAGE4SOURCE': 'Python', 'COUNT4SOURCE': 1   
                except:
                    print('(Step 940Z1/25) OF KERNEL4XI5TEST *** FAILED TO BUILD XI: ', time4xi())

            
            print('FOCUS 310')
            if KB4Focus['sense'] == 'NACK4XI':              
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SENSE KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 970A/700) OF KERNEL4XI5TEST - SENSING ', time4xi())  
                try:
                    response4sense = p2xi.sense()
                    print('(Step 970B/700) OF KERNEL4XI5TEST - SENSED ', time4xi())
                except:
                    print('(Step 970Z1/700) OF KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())
                try:         
                    print(response4sense)
                    # {'object': <kernel4xi.Kernel4Xi object at 0x000000000550A7F0>, 'classvariable2xi-of-Kernel4Xi': 4}
                except:
                    print('(Step 970Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4sense ', response4sense)          
                        
            print('FOCUS 320')
            if KB4Focus['reason'] == 'NACK4XI':             
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - REASON KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 980A/700) OF KERNEL4XI5TEST - REASONING ', time4xi())  
                try:
                    response4reason = p2xi.reason()
                except:
                    print('(Step 980Z1/700) OF KERNEL4XI5TEST *** FAILED TO REASON ', time4xi())
                try:                        
                    print(response4reason)
                    # {'object-reason-object4xi': <kernel4xi.Kernel4Xi object at 0x00000000056DA7F0>, 'time-reason-of-Kernel4Xi': '09:32:07 11/30/11 Pacific Standard Time'}
                except:
                    print('(Step 980Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4reason ', response4reason)                                  
            
            print('FOCUS 330')
            if KB4Focus['ace'] == 'NACK4XI':                 
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ACE KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 990A/700) OF KERNEL4XI5TEST - ACING ', time4xi())  
                try:
                    response4ace = p2xi.ace()
                except:
                    print('(Step 990Z1/700) OF KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())
                try:                
                    print(response4ace)
                    # {'cores-of-Kernel4Xi': 4, 'object8xi': <kernel4xi.Kernel4Xi object at 0x000000000568A7F0>}
                except:
                    print('(Step 990Z2/700) OF KERNEL4XI5TEST *** FAILED TO PRINT response4ace ', response4ace)                                  
             
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 174/700) OF KERNEL4XI5TEST - DONE! ', time4xi())
        # 

    except:
        print('(Step 175/700) OF KERNEL4XI5TEST *** FAILED ****  ', time4xi())

#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for kernel4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
    global trace2scope
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    trace2scope = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    print('=' *33)
    print("(Step 0A/700) OF KERNEL4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi()) 
    # 
    print('=' *33)
    try:     
    
        kernel4xi5test()  
    
        print('=' *33)
        print("(Step 0B/700) OF KERNEL4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi()) 
        # 
        print('=' *33)
    except:
        pass
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(trace2scope)                      
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# kernel4xi5test.txt
# sense-kernel4xi5test.xml
# reason-kernel4xi5test.xml
# ace-kernel4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of kernel4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
